package EDU.auburn.VGJ.gui;

/*
 *	File: GraphWindow.java
 *
 *	5/29/96   Larry Barowski
*/
//version pass jake pict 02/07/01


import clad.*;
import java.awt.Frame;
import java.awt.Label;
import java.awt.Button;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.Event;
import java.awt.Color;
import java.awt.Choice;
import java.awt.Panel;
import java.awt.Scrollbar;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.net.URL;
import java.awt.Font;
import java.awt.Image;
import java.awt.image.ImageProducer;
import java.awt.Dimension;
import java.awt.CheckboxMenuItem;
import java.awt.FileDialog;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.FlowLayout;
import java.util.Hashtable;
import java.io.StringBufferInputStream;
import java.io.FileInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.InputStream;
import EDU.auburn.VGJ.util.DDimension;
import EDU.auburn.VGJ.util.DPoint;
import EDU.auburn.VGJ.util.DPoint3;
import EDU.auburn.VGJ.algorithm.GraphAlgorithm;
import EDU.auburn.VGJ.graph.Node;
import EDU.auburn.VGJ.graph.Graph;
import EDU.auburn.VGJ.graph.GMLlexer;
import EDU.auburn.VGJ.graph.GMLobject;
import EDU.auburn.VGJ.graph.ParseError;
import java.lang.System;
import EDU.auburn.VGJ.gui.ScrolledPanel;
import EDU.auburn.VGJ.gui.ViewportScroller;
//import EDU.auburn.VGJ.nesting.*; //jake 2-7-01
//import EDU.auburn.VGJ.calc.*;  //jake 2-7-01

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;

import java.awt.event.*;



/**
 *	GraphWindow is a graph editing tool window.
 *	</p>Here is the <a href="../gui/GraphWindow.java">source</a>.
 *
 *@author	Larry Barowski
**/
public class GraphWindow extends JFrame {

	/**
	   *	spacing of controls
	   **/
	protected static int spacing_ = 4; // spacing between controls

	private Graph graph_;
	private GraphCanvas graphCanvas_;
	private Panel controls_;
	private CheckboxMenuItem showControls_;
	private ViewportScroller portScroller_;
	private ScrolledPanel viewingPanel_;
	private Label scaleLabel_;
	private double scale_ = 1.0;
	private Menu algorithmMenu_;
	private Hashtable algHashTable_;
	private Hashtable algNameHashTable_;
	private Hashtable menuHashTable_;
	private CheckboxMenuItem cbmiDirected_;
	private String filename_ = null;
	private GMLobject GMLfile_ = null;
	private PSdialog psDialog_ = null;
	private pictdialog pictDialog_ = null;
	//private CalcDialog calcDialog_ = null; //jake 2-7-01
	//private NestDialog nestDialog_ = null; //jake 2-7-01
	private AlgPropDialog algPropDialog_ = null;
	private FontPropDialog fontPropDialog_ = null;
	private GroupControl groupControl_ = null;
	private static URL context_ = null;
	private FileDialog fd  = null;
	private FileDialog fd1 = null;
	private FileDialog fd2 = null;
	private FileDialog fd3 = null;
	public static JProgressBar progressBar;
	public static LPanel p;
    public static JTextField textField;
	public static Button run_button = new Button("RUN");
	public static Button stop_button = new Button("STOP");
	public static dna dnac;
	public String filename, outfile;
	public JLabel infilelabel;
	public static JTextField statustextField;
	private Timer timer = new Timer(ONE_SECOND, new TimerListener());                                 
	public final static int ONE_SECOND = 1000;	
	public boolean cancel = false;
 	private boolean doDistances = false;
	public static Menu weightsMenu = new Menu("Outgroup Weights");

	  public GraphWindow(Graph graph_in)
	  {
		 construct(graph_in);
	  }  
	  public GraphWindow(boolean directed)
	  {
		 construct(new Graph(directed));
	  }  
public boolean action(Event event, Object what) {

	if (event.target instanceof Choice) {
		Choice choice = ((Choice) (event.target));
		String label = choice.getSelectedItem();
		
		if (label.equals("Gaps = 5th state"))
			dna.gapmode = true;
		else 
			if (label.equals("Gaps = missing"))
				dna.gapmode = false;

		int mode = GraphCanvas.SELECT_BOTH;

		if (label.equals("Create Branches"))
			mode = GraphCanvas.CREATE_EDGES;
		else
			if (label.equals("Create Nodes"))
				mode = GraphCanvas.CREATE_NODES;
			else
				if (label.equals("Select Branches"))
					mode = GraphCanvas.SELECT_EDGES;
				else
					if (label.equals("Select Nodes"))
						mode = GraphCanvas.SELECT_NODES;
					else 
						if (label.equals("Select Nodes & Branches"))
							mode = GraphCanvas.SELECT_BOTH;
	
		graphCanvas_.setMouseMode(mode);

	}

/*
	if (event.target instanceof Checkbox) {
		CheckboxGroup cbgrp = ((Checkbox) (event.target)).getCheckboxGroup();
		Checkbox selected = cbgrp.getCurrent();
		String label = selected.getLabel();
		int mode = GraphCanvas.SELECT_BOTH;

		if (label.equals("Create Branches"))
			mode = GraphCanvas.CREATE_EDGES;
		else
			if (label.equals("Create Nodes"))
				mode = GraphCanvas.CREATE_NODES;
			else
				if (label.equals("Select Branches"))
					mode = GraphCanvas.SELECT_EDGES;
				else
					if (label.equals("Select Nodes"))
						mode = GraphCanvas.SELECT_NODES;
			
		if (label.equals("Gaps = 5th state"))
			dna.gapmode = true;
		else
			if (label.equals("Gaps = missing"))
				dna.gapmode = false;
	
		graphCanvas_.setMouseMode(mode);

	} */ else
		if (event.target instanceof CheckboxMenuItem) {
			String label = ((CheckboxMenuItem) (event.target)).getLabel();
			boolean state = ((CheckboxMenuItem) (event.target)).getState();
			if (label.equals("Scale Node Size"))
				graphCanvas_.scaleBounds(state);
			else
				if (label.equals("Show Controls  [s]")) {
					if (state)
						controls_.show();
					else
						controls_.hide();
					validate();
				} else
					if (label.equals("Directed"))
						graphCanvas_.setDirected(state);
					else
						if (label.equals("Use Node ID As Default Label")) {
							Node.setDefaultLabel(state);
							graphCanvas_.update(false);
						} else
							if (label.equals("High Quality Display"))
								graphCanvas_.setQuality(state == false ? 1 : 2);
		} else
			if (event.target instanceof MenuItem) {
				GraphAlgorithm alg;
				MenuItem menuitem = (MenuItem) event.target;
				alg = (GraphAlgorithm) algHashTable_.get(menuitem);
				if (alg != null) {	
					applyAlgorithm_(alg);
				} else {
					String label = menuitem.getLabel();

					if (label.equals("Help")) {
						JFrame frame = new JFrame();
						JOptionPane.showMessageDialog(frame,"Read the documentation...",
			                "TCS advice", JOptionPane.INFORMATION_MESSAGE);		
						frame.dispose();		
					}

					else if (label.equals("Citation")) {
						JFrame frame = new JFrame();
						JOptionPane.showMessageDialog(frame,"Clement M, Posada D, Crandall KA. 2000" +
						"\nTCS: a computer program to estimate gene genealogies" +
						"\nMolecular Ecology 9 (10): 1657-1660" +
						"\n\nhttp://bioag.byu.edu/zoology/crandall_lab/programs.htm",
		                "TCS citation", JOptionPane.INFORMATION_MESSAGE);		
						frame.dispose();		
					}

					else if (label.equals("Credits")) {
						JFrame frame = new JFrame();
						JOptionPane.showMessageDialog(frame,"TCS is being developed by several people:" +
						"\n   Mark Clement\n   Jacob Derington\n   David Posada" +
						"\n\n   @BYU Computer Science (MC, JD) & Zoology (DP)" +
						"\n\nTCS uses the freeware VGLJ for graph display and manipulation and GUI architecture" +
						"\n   http://www.eng.auburn.edu/department/cse/research/graph_drawing/graph_drawing.html" +
						"\n   VGJ may be distributed under the terms of the GNU General Public License, Version 2" +
						"\n\nThanks to all the users for reporting problems !",
						"TCS credits", JOptionPane.INFORMATION_MESSAGE);		
						frame.dispose();		
					}

					else if (label.equals("Open Example Graph")) {
						URL src = null;
						try {
							src = new URL(context_, "example.gml");
							InputStream strm = src.openStream();
							GMLlexer lexer = new GMLlexer(strm);
							GMLfile_ = new GMLobject(lexer, null);
							GMLobject gmlgraph = GMLfile_.getGMLSubObject("graph", GMLobject.GMLlist, false);
							Graph newgraph = null;
							newgraph = new Graph(gmlgraph);
							graph_.copy(newgraph);
							graphCanvas_.update(true);
							filename_ = null;
							setTitle_();
						} catch (Exception e) {
							new MessageDialog(this, "Error", "Error loading example graph.", true);
						};
					} else
						if (label.equals("Open Graph (GML)")) {
							String filename = null;

							//FileDialog fd1;
							if (fd1 == null) {
								try {
									fd1 = new FileDialog(this, "Open VGJ File (GML) graph", FileDialog.LOAD);
									fd1.show();
								} catch (Throwable e) {
									MessageDialog dg = new MessageDialog(this, "Error", "It appears your VM does not allow file loading.", true);
									return true;
								}
							} else {
								fd1.show();
							}
							filename = fd1.getFile();
							if (filename == null) {
								fd1 = null;
								return true;
							}
							filename = fd1.getDirectory() + filename;
							loadFile(filename);
							return true;
						} else
						  if (label.equals("Select NEXUS/PHYLIP Sequence file")) {
							filename = null;
							dnac = new dna(); 
							if (fd2 == null) {
								try {
									fd2 = new FileDialog(this, "Open DNA File (Nexus or Phylip sequential)", FileDialog.LOAD);
									fd2.show();
								} catch (Throwable e) {
									MessageDialog dg = new MessageDialog(this, "Error", "It appears your VM does not allow file loading.", true);
									return true;
								}
							} else {
								fd2.show();
							}
							filename = fd2.getFile();
							if (filename == null) {
								fd2 = null;
								return true;
							}
							infilelabel.setText(filename);
							outfile = filename;
							outfile = outfile.concat(".graph");
							filename = fd2.getDirectory() + filename;
							if (filename == null){
								JFrame frame = new JFrame();
								JOptionPane.showMessageDialog(frame,"Cannot open data file",
								 "TCS warning", JOptionPane.WARNING_MESSAGE);		
								frame.dispose();				
								System.exit(0);
							}
							run_button.setEnabled(true);
							stop_button.setEnabled(true);
							return true;
						} 
						else
						  if (label.equals("Select NEXUS/PHYLIP Distance file")) {
							filename = null;
							dnac = new dna(); 
							if (fd2 == null) {
								try {
									fd2 = new FileDialog(this, "Open DNA Distances File (Nexus or Phylip lower matrix)", FileDialog.LOAD);
									fd2.show();
								} catch (Throwable e) {
									MessageDialog dg = new MessageDialog(this, "Error", "It appears your VM does not allow file loading.", true);
									return true;
								}
							} else {
								fd2.show();
							}
							filename = fd2.getFile();
							if (filename == null) {
								fd2 = null;
								return true;
							}
							infilelabel.setText(filename);
							outfile = filename;
							outfile = outfile.concat(".graph");
							filename = fd2.getDirectory() + filename;
							doDistances = true;
							if (filename == null){
								JFrame frame = new JFrame();
								JOptionPane.showMessageDialog(frame,"Cannot open distance file",
								 "TCS warning", JOptionPane.WARNING_MESSAGE);		
								frame.dispose();				
								System.exit(0);
							}
							
							run_button.setEnabled(true);
							stop_button.setEnabled(true);

							return true;
						
						
						} else
							if (label.equals("Save Graph (GML)") || label.equals("Save Graph As (GML)")) {
								try {
									String filename;
									if (label.equals("Save Graph As (GML)") || filename_ == null) {
										//FileDialog fd;
										if (fd == null) {
											try { 
												fd = new FileDialog(this, "Save VGJ File (GML) Graph", FileDialog.SAVE);
												fd.show();
											} catch (Throwable e) {
												MessageDialog dg = new MessageDialog(this, "Error", "It appears your VM does not allow file saving.", true);
												return true;
											}
										} else {
											fd.show();
										}
										filename = fd.getFile();
										if (filename == null) {
											fd = null;
											return true;
										}
										// Work around JDK Windows bug.
										if (filename.endsWith(".*.*")) {
											String tmpstr = filename.substring(0, filename.length() - 4);
											filename = tmpstr;
										}
										filename = fd.getDirectory() + filename;
									} else
										filename = filename_;
									PrintStream ps = new PrintStream(new FileOutputStream(filename));
									if (GMLfile_ == null) {
										GMLfile_ = new GMLobject(null, GMLobject.GMLfile);
										GMLfile_.addObjectToEnd(new GMLobject("graph", GMLobject.GMLlist));
									}
									GMLobject gmlgraph = GMLfile_.getGMLSubObject("graph", GMLobject.GMLlist, false);
									graph_.setGMLvalues(gmlgraph);
									gmlgraph.prune();
									ps.println(GMLfile_.toString(0));
									ps.close();
									filename_ = filename;
									setTitle_();
								} catch (IOException e) {
									MessageDialog dg = new MessageDialog(this, "Error", e.getMessage(), true);
								}
							} else
								if (label.equals("Exit This Window"))
									Destroy();
								else
									if (label.equals("Delete Selected Items"))
										graphCanvas_.deleteSelected(true);
									else
										if (label.equals("Select All"))
											graphCanvas_.selectAll();
										else
											if (label.equals("Remove All Edge Bends"))
												graphCanvas_.removeEdgeBends();
											else
												if (label.equals("Remove All Groups"))
													graphCanvas_.removeGroups();
												else
													if (label.equals("Group Control")) {
														if (groupControl_ == null)
															groupControl_ = new GroupControl(this, graphCanvas_);
														else
															groupControl_.showMe();
													} else
														if (label.equals("Set New Node Properties"))
															graphCanvas_.setNodeProperties(true);
														else
															if (label.equals("Set Node Spacing")) {
																if (algPropDialog_ == null)
																	algPropDialog_ = new AlgPropDialog(this, graphCanvas_);
																else
																	algPropDialog_.showMe();
															} else
																if (label.equals("Set Font")) {
																	if (fontPropDialog_ == null)
																		fontPropDialog_ = new FontPropDialog(this, graphCanvas_);
																	else
																		fontPropDialog_.showMe();
																} else
																	if (label.equals("Edit Text Representation (GML)")) {
																		graphCanvas_.unselectItems();
																		GraphEdit ge = new GraphEdit(graph_, graphCanvas_);
																		ge.pack();
																		ge.show();
																	} else
																		if (label.equals("PostScript Output")) {
																			if (psDialog_ == null)
																				psDialog_ = new PSdialog(this, graphCanvas_);
																			else {
																				psDialog_.pack();
																				psDialog_.show();
																			}
																		}
																	else if (label.equals("PICT Format Output")) {
																			if (pictDialog_ == null)
																				pictDialog_ = new pictdialog(this, graphCanvas_);
																			else {
																				pictDialog_.pack();
																				pictDialog_.show();
																			}
																		}
																	/*else if (label.equals("Cladograph nesting")) //added 9-11 jake
																	{
																		//call a nesting program of the graph
																		if (nestDialog_ == null)
																				nestDialog_ = new NestDialog(this, graphCanvas_,dnac);
																			else {
																				nestDialog_.pack();
																				nestDialog_.show();
																			}
																	}
																	else if (label.equals("Clads Base pair changes")) //added 9-11 jake
																	{
																		//call a program to get a determination of the
																		//dna base pair changed in the cadeogram
																		if (calcDialog_ == null)
																				calcDialog_ = new CalcDialog(this, graphCanvas_,dnac);
																			else {
																				calcDialog_.pack();
																				calcDialog_.show();
																			}
																	}*/  //jake 02-07-01
															else if (label.equals("Plot histogram")) {
																		new Histogram(dna.outweights, dna.xlabels);
																		}
									}									
			} else
				if (event.target instanceof Button) {
					if (((String) what).equals("Scale / 1.5")) {
						scale_ /= 1.5;
						graphCanvas_.setScale(scale_);
						scaleLabel_.setText("Scale: " + scale_);
					} else
						if (((String) what).equals("Scale * 1.5")) {
							scale_ *= 1.5;
							graphCanvas_.setScale(scale_);
							scaleLabel_.setText("Scale: " + scale_);
						} else
							if (((String) what).equals("Scale = 1")) {
								scale_ = 1.0;
								graphCanvas_.setScale(scale_);
								scaleLabel_.setText("Scale: " + scale_);
							} else
								if (((String) what).equals("Center")) {
									DDimension port_dim = viewingPanel_.getPortSize();
									DDimension cont_dim = viewingPanel_.getContentSize();
									double x = (cont_dim.width - port_dim.width) / 2.0;
									double y = (cont_dim.height - port_dim.height) / 2.0;
									viewingPanel_.scrollTo((int) x, (int) y);
									portScroller_.setOffset(x, y);
								} else
									if (((String) what).equals("RUN")) {
									//timer.start();
									dnac.dodna(filename,fd2.getDirectory() + outfile,0,doDistances);		
									if (dna.graph_exists) {
										loadFile(fd2.getDirectory() + outfile);
										graphCanvas_.selectAll();
										applyAlgorithm("Tree Down");
										fd2 = null;
									}
									else
										System.exit(0);
								}
									else if (((String) what).equals("STOP")) {
									//timer.stop();
									//System.exit(0);
									hide();
									cancel = true;
								}

				}
	return true;
}
	  public void addAlgorithm(GraphAlgorithm alg, String name)
	  {
		 MenuItem menuitem;
	  
		 menuitem = new MenuItem(name);
		 algorithmMenu_.add(menuitem);
	  
	  	 // Algorithms keyed by menuitems.
		 algHashTable_.put(menuitem, alg);
		 algNameHashTable_.put(name, alg);
	  }  
	  public void addAlgorithm(GraphAlgorithm alg, String menuname, String name)
	  {
		 
		 Menu menu = (Menu) menuHashTable_.get(menuname);
		 if(menu == null)
			return;
	  
		 MenuItem menuitem = new MenuItem(name);
		 menu.add(menuitem);
	  
		 algHashTable_.put(menuitem, alg);
		 algNameHashTable_.put(menuname + "." + name, alg);
	  }  
	  public void addAlgorithmMenu(String name)
	  {
		 Menu menu;
	  
		 menu = new Menu(name);
		 algorithmMenu_.add(menu);
	  
	  	// Menus keyed by names.
		 menuHashTable_.put(name, menu);
	  }  
	  public void applyAlgorithm(String name)
	  {
		  GraphAlgorithm alg = (GraphAlgorithm) algNameHashTable_.get(name);
					
		  if(alg != null)
			{
			   applyAlgorithm_(alg);
			}
	  }  
	  public void applyAlgorithm_(GraphAlgorithm alg)
	  {
			   if(graph_.numberOfNodes() < 1)
				  new MessageDialog(this, "Error", "Graph is empty.", true);
			   else
			   {
				  graph_.removeGroups();  // Remove group nodes.
				  graph_.pack();  // Pack the indexes.
			   
				  String msg;
				  graphCanvas_.setWireframe(true);
				  msg = alg.compute(graph_, graphCanvas_);
				  graphCanvas_.setWireframe(false);
			   
				  if(msg != null)
					 new MessageDialog(this, "Message", msg, true);
			   
				  graphCanvas_.update(true);
			   }
	  }  
	  private void construct(Graph graph_in)
	  {
		 algHashTable_ = new Hashtable();
		 algNameHashTable_ = new Hashtable();
		 menuHashTable_ = new Hashtable();
	  	// create menus
		 boolean directed = graph_in.isDirected();
		 MenuBar menubar = new MenuBar();
		 Menu menu = new Menu("File");
		 Menu TCSmenu = new Menu("TCS");
		 Menu weightsMenu = new Menu ("Outgroup weights");
		 menu.add(new MenuItem("-"));
		 menu.add(new MenuItem("Select NEXUS/PHYLIP Sequence file"));
		 menu.add(new MenuItem("-"));
//		 menu.add(new MenuItem(" "));
		 menu.add(new MenuItem("Select NEXUS/PHYLIP Distance file"));
		 menu.add(new MenuItem("-"));
		 menu.add(new MenuItem("Open Graph (GML)"));
		 menu.add(new MenuItem("Save Graph (GML)"));
		 menu.add(new MenuItem("Save Graph As (GML)"));
		 //menu.add(new MenuItem("-"));
		 //menu.add(new MenuItem("Open Example Graph"));
		 menu.add(new MenuItem("-"));
		 menu.add(new MenuItem("PostScript Output"));
	     menu.add(new MenuItem("PICT Format Output"));
		 //menu.add(new MenuItem("-"));
		 //menu.add(new MenuItem("Cladogram nesting")); //jake 02-07-01
		 //menu.add(new MenuItem("Clads Base pair changes"));//jake 02-07-01
		 menu.add(new MenuItem("-")); 
		 menu.add(new MenuItem("Exit This Window"));
		 menubar.add(menu);
	  
		 algorithmMenu_ = new Menu("Tree");
		 menubar.add(algorithmMenu_);

		 TCSmenu.add(new MenuItem("Help"));
		 TCSmenu.add(new MenuItem("Credits"));
		 TCSmenu.add(new MenuItem("Citation"));
		 menubar.add(TCSmenu);

		 weightsMenu.add(new MenuItem("Plot histogram"));
		 weightsMenu.setEnabled(true);
		 //menubar.add(weightsMenu);
	  	 
	  	 menu = new Menu("Edit Graph");
		 menu.add(new MenuItem("Select All"));
		 menu.add(new MenuItem("Delete Selected Items"));
		 menu.add(new MenuItem("Remove All Edge Bends"));
		 menu.add(new MenuItem("Remove All Groups"));
		 menu.add(new MenuItem("Group Control"));
		 menu.add(new MenuItem("Edit Text Representation (GML)"));
		 menubar.add(menu);
	  
		 menu = new Menu("Properties");

    	 progressBar = new JProgressBar(0, 100);
         progressBar.setValue(0);
         progressBar.setStringPainted(true);
 		 
		 showControls_ = new CheckboxMenuItem("Show Controls  [s]");
		 showControls_.setState(true);
		 menu.add(showControls_);

		 CheckboxMenuItem cbmi = new CheckboxMenuItem("Directed");
		 cbmiDirected_ = cbmi;
		 if(directed)
			cbmi.setState(true);
		 menu.add(cbmi);
	  
		 menu.add(new MenuItem("Set New Node Properties"));
		 menu.add(new MenuItem("Set Node Spacing")); 
		 menu.add(new MenuItem("Set Font")); 
	  
		 cbmi = new CheckboxMenuItem("Scale Node Size");
		 cbmi.setState(true);
		 menu.add(cbmi);
	  
		 cbmi = new CheckboxMenuItem("Use Node ID As Default Label");
		 cbmi.setState(true);
		 menu.add(cbmi);
	  
		 cbmi = new CheckboxMenuItem("High Quality Display");
		 cbmi.setState(true);
		 menu.add(cbmi);
	  
		 menubar.add(menu);
	  
		 setMenuBar(menubar);
		 getContentPane().setLayout(new BorderLayout());
 
	  	// panel for controls 
		 p = new LPanel();
	     //p.setFont (new Font ("Charcoal", Font.PLAIN, 12));
		 p.setForeground(Color.black);
		
		p.setBorder(BorderFactory.createEtchedBorder());
//		p.setBorder(BorderFactory.createLineBorder(Color.black));
//		p.setBorder(BorderFactory.createRaisedBevelBorder());
//		p.setBorder(BorderFactory.createLoweredBevelBorder());


        // Lay out everything
		 
		p.addLineLabel("TCS CLADOGRAM ESTIMATION", 0);

		textField = new JTextField(20);

    	infilelabel = new JLabel("No input file");

  		statustextField= new JTextField(25);
  	 	statustextField.setText("STATUS: Waiting");
		statustextField.setForeground(Color.red);
		statustextField.setBackground(Color.lightGray);
	    statustextField.update(GraphWindow.textField.getGraphics());

 	    p.setFont (new Font ("Charcoal", Font.PLAIN, 11));

  	 	p.addComponent(infilelabel, 1, -1, 1 ,1, 0, 0);							
		run_button.setEnabled(false);
    	stop_button.setEnabled(false);
  		p.addComponent(run_button, 1, -1, 1 ,1, 0, 0);							
		//p.addComponent(stop_button,1, -1, 1, 1, 0, 0);
		p.addLineLabel("", 0);

		 p.addComponent(progressBar, 1, -1, 1 ,1, 0, 0);							
   		 p.addLineLabel("", 0);
	 	 p.addComponent(textField, 1, -1, 1 ,1, 0, 0);							
		 textField.setText("Calculate 95% connection limit");
		 textField.setBackground(Color.lightGray);
		 p.addLineLabel("", 0);

	    Choice choicegaps; //pop-up list of choices
	    choicegaps = new Choice();
	    choicegaps.addItem("Gaps = 5th state");
	    choicegaps.addItem("Gaps = missing");
		p.addComponent(choicegaps, 1, -1, 1 ,1, 0, 0);							

	//	p.add(choicegaps);	
        p.addLineLabel("", 0);

	    Choice choicesel; //pop-up list of choices
	    choicesel = new Choice();
	    choicesel.addItem("Select Nodes & Branches");
	    choicesel.addItem("Select Nodes");
		choicesel.addItem("Select Branches");
        choicesel.addItem("Create Nodes");
	    choicesel.addItem("Create Branches");
//		p.add(choicesel);	
 		p.addComponent(choicesel, 2, -2, 2 ,2, 0, 0);							
        p.addLineLabel("", 0);

/*	
		 CheckboxGroup mode_group = new CheckboxGroup();
		 p.constraints.insets.bottom = 0;
		 p.addCheckbox("Create Nodes", mode_group, false, 1, -1, 1.0, 1.0, 0, 0);
		 p.addCheckbox("Create Branches", mode_group, false, 0, -1, 1.0, 1.0, 0, 0);
		 p.constraints.insets.top = p.constraints.insets.bottom = 0;
		 p.addCheckbox("Select Nodes", mode_group, false, 1, -1, 1.0, 1.0, 0, 0);
		 p.addCheckbox("Select Branches", mode_group, false, 0, -1, 1.0, 1.0, 0, 0);
		 p.addCheckbox("Select Nodes or Branches", mode_group, true, 0, -1, 1.0, 1.0, 0, 0);
*/

		 portScroller_ = new ViewportScroller(90, 90, 500.0, 500.0, 400.0, 400.0, 0.0, 0.0);
         portScroller_.setBackground(Color.white);
	  
		 p.constraints.insets.bottom = 0;
		 p.addLabel("Viewing Offset", 0, 0, 1.0, 1.0, 0, 0);
		 p.constraints.insets.top = p.constraints.insets.bottom = 0;
		 p.addComponent(portScroller_, 0, 0, 1.0, 1.0, 0, 0);
		 p.constraints.insets.top = p.constraints.insets.bottom = 0;
		 p.addButton("Center", 0, 0, 1.0, 1.0, 0, 0);
	  
		 scaleLabel_ = p.addLineLabel("Scale: 1", 0);     
	 	
	
		 LPanel sp = new LPanel();
		 	    sp.setFont (new Font ("Charcoal", Font.PLAIN, 11));
		  sp.spacing = 0;
		 sp.constraints.insets.top = sp.constraints.insets.bottom = 0;
		 sp.addButton("Scale / 1.5", 1, -1, 1.0, 1.0, 0, 0);
		 sp.addButton("Scale = 1", 1, -1, 1.0, 1.0, 0, 0);
		 sp.addButton("Scale * 1.5", 0, -1, 1.0, 1.0, 0, 0);
		 sp.finish();
	  
		 p.addComponent(sp, 0, 0, 1.0, 1.0, 0, 0);
	  
		 p.constraints.insets.top = 0;
		 AngleControlPanel angc = new AngleControlPanel(180, 76);
		 //p.addComponent(angc, 0, 0, 1.0, 1.0, 1, 0);
	  
	     p.addLineLabel("", 0);
 	 	 p.addComponent(statustextField, 1, -1, 1 ,1, 0, 0);							
  
	  	// super panel is there just to allow controls to be
	  	// fixed to top instead of centered
		 Panel controls_superpanel = new Panel();
		 controls_superpanel.add("North", p);
		 p.finish();
		 getContentPane().add("West", controls_superpanel);
		 controls_ = controls_superpanel;
	  
		 graph_ = graph_in;
	  
	  
		 Node.defaults.setBoundingBox(20, 20, 20);
	  
	  	// the graph viewing canvas
		 graphCanvas_ = new GraphCanvas(graph_, this);
	  
	  	// the graph viewing panel (canvas and scrollbars)
		 viewingPanel_ = new ScrolledPanel(graphCanvas_);
		 getContentPane().add("Center", viewingPanel_);
		 setBackground(Color.lightGray);
		 validate();
	  }  
   // Function is called on an exit menu choice or delete from the WM menu
	  private void Destroy()
	  {
		 dispose();
	  }  
	  public boolean handleEvent(Event event)
	  {
		 if(event.target instanceof ScrolledPanel)
		 {
			if(event.id == ScrolledPanel.RESIZE)
					// RESIZE event from panel.
			{
			   DDimension tmp_dim;
			
			   tmp_dim = viewingPanel_.getPortSize();
			   portScroller_.setPortSize(tmp_dim.width, tmp_dim.height);
			
			   tmp_dim = viewingPanel_.getContentSize();
			   portScroller_.setContentSize(tmp_dim.width, tmp_dim.height);
			
			   tmp_dim = viewingPanel_.getOffset();
			   portScroller_.setOffset(tmp_dim.width, tmp_dim.height);
			
			   return true;
			}
			else if(event.id == ScrolledPanel.OFFSET)
			{
			   DDimension tmp_dim = viewingPanel_.getOffset();
			   portScroller_.setOffset(tmp_dim.width, tmp_dim.height);
			
			   return true;
			}
		 }
		 else if(event.target instanceof ViewportScroller)
		 {
			if(event.id == ViewportScroller.SCROLL) {
			   graphCanvas_.setWireframe(true);
			   viewingPanel_.scrollTo((int)portScroller_.getOffsetX(),
										 (int)portScroller_.getOffsetY());
			}
			if(event.id == ViewportScroller.DONE) {
			   graphCanvas_.setWireframe(false);
			   viewingPanel_.scrollTo((int)portScroller_.getOffsetX(),
										 (int)portScroller_.getOffsetY());
			}
		 }
		 else if(event.target instanceof AngleControlPanel)
		 {
			if(event.id == AngleControlPanel.ANGLE) {
			   DPoint	angles = (DPoint)event.arg;
			
			   graphCanvas_.setWireframe(true);
			   graphCanvas_.setViewAngles(angles.x, angles.y);
			}
			if(event.id == AngleControlPanel.DONE) {
			   DPoint	angles = (DPoint)event.arg;
			
			   graphCanvas_.setWireframe(false);
			   graphCanvas_.setViewAngles(angles.x, angles.y);
			}
		 }
		 else if(event.target instanceof GraphCanvas)
			// Graph has changed.
		 {
			if(event.id == GraphCanvas.UPDATE)
			{
			   cbmiDirected_.setState(graph_.isDirected());
			}
		 }
		 // quit from Window Manager menu
		 else if(event.id == Event.WINDOW_DESTROY)
		 {
			Destroy();
			return false;
		 }
	  
	  	// call inherited handler
		 return super.handleEvent(event);
	  }  
	  public boolean keyDown(Event e, int key)
	  {
		 if(e.id == Event.KEY_PRESS) {
	    if(key == 's')
	       showControls_.setState(!showControls_.getState());
	    else
			   graphCanvas_.keyDown(e, key);
			   if(showControls_.getState())
		  controls_.show();
	       else
		  controls_.hide();
	       validate();
			}
	  
		 return false;
	  }  
		// FIXME duplicated code feb22-01 david & jake
		public void loadFile ( InputStream InputStream )
	  {
					 GMLlexer lexer = new GMLlexer(InputStream );
				  
				  
					 try
					 {
						GMLfile_ = new GMLobject(lexer, null);
						GMLobject gmlgraph = GMLfile_.getGMLSubObject("graph", GMLobject.GMLlist, false);
						if(gmlgraph == null)
						{
						   GMLfile_ = null;
						   new MessageDialog(this, "Error",
											 "File does not contain a graph.", true);
						   return;
						}
					 
						Graph newgraph = null;
					 
						newgraph = new Graph(gmlgraph);
						graph_.copy(newgraph);
						graphCanvas_.update(true);
					 
						filename_ = filename;
						setTitle_();
					 }
						catch(ParseError error)
						{
						   new MessageDialog(this,
											 "Error", error.getMessage() +
											 " at line " + lexer.getLineNumber() +
											 " at or near \""
											 + lexer.getStringval() + "\".", true);
						   return;
						}
						catch(IOException error)
						{
						   MessageDialog dg = new MessageDialog(this,
															   "Error", error.getMessage(), true);
						   return;
						}
					

	  }  
		
	  public void loadFile(String filename)
	  {
			  try {
					 File fname = new File(filename);
					 int size = (int)fname.length();
					 int bytes_read = 0;
					 FileInputStream infile = new FileInputStream(fname);
					 byte[] data = new byte[size];
					 while (bytes_read < size)
						bytes_read += infile.read(data, bytes_read, size - bytes_read);
				  
					 StringBufferInputStream stream = new StringBufferInputStream(new String(data, 0));
					 GMLlexer lexer = new GMLlexer(stream);
				  
				  
					 try
					 {
						GMLfile_ = new GMLobject(lexer, null);
						GMLobject gmlgraph = GMLfile_.getGMLSubObject("graph", GMLobject.GMLlist, false);
						if(gmlgraph == null)
						{
						   GMLfile_ = null;
						   new MessageDialog(this, "Error",
											 "File does not contain a graph.", true);
						   return;
						}
					 
						Graph newgraph = null;
					 
						newgraph = new Graph(gmlgraph);
						graph_.copy(newgraph);
						graphCanvas_.update(true);
					 
						filename_ = filename;
						setTitle_();
					 }
						catch(ParseError error)
						{
						   new MessageDialog(this,
											 "Error", error.getMessage() +
											 " at line " + lexer.getLineNumber() +
											 " at or near \""
											 + lexer.getStringval() + "\".", true);
						   return;
						}
						catch(IOException error)
						{
						   MessageDialog dg = new MessageDialog(this,
															   "Error", error.getMessage(), true);
						   return;
						}
				  }
					 catch (FileNotFoundException e)
					 {
						MessageDialog dg = new MessageDialog(this,
							"Error", "Error loading file  \"" + filename + "\".", true);
					 }
				  
					 catch (IOException e)
					 {
						MessageDialog dg = new MessageDialog(this,
															"Error", e.getMessage(), true);
					 }


	  }  
	  public void selectNode(int node_index) {
		 graphCanvas_.selectNode(node_index);
	  }  
	  public static void setContext(URL context)
	  {
		 context_ = context;
	  }  
	  private void setTitle_()
	  {
		 if(filename_ != null)
			setTitle("TCS " + dna.VERSION + ":   " + filename_);
	  }  
   /**
     * The actionPerformed method in this class
     * is called each time the Timer "goes off".
     */
    class TimerListener implements ActionListener 
    {
        public void actionPerformed(ActionEvent evt) 
        {     
            if (cancel) 
            {
        	 	System.out.print("Stop button pressed ");
                timer.stop();
				System.exit(0);
			} 
        }
    }
}



