/*
 * Created on May 16, 2005
 * Created by wooo as part of TCS
 * Implementation of Taylor Maxwell's Macanova macros to map characters back onto a TCS graph
 */
package clad;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Vector;

/**
 * @author wooo
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CharacterMapper {

    //file of macros to map character in TCS
    //fTCS is primary macro all others are called from
    //it spits out an output graphfile with mapped sites (defaults to fendout[2] version with just sites 
    //it also outputs structure with outputs from [1]rdTCSout,[2]TCSnode,[3]difsum,[4]fpath,[5]difin,
    //[6]fassign, [7]fmatch,[8]fsite,[9]fend,[10]do=hap-hap/hap-int combos
    //NOTE: [9]fend output can be pasted as the entire new graph file [1]has all info on branch, [2]has only site numbers
    //......[8]c1=site//,c2=//branches it is on, c3-cend=the actual branches they occurs
    //if write macrousage(fTCSdescribe) will get more thorough explanation
    //uses fTCS,rdTCS, TCSnode, DIFSUM, FPATH, DIFIN, FASSIGN,
    //FMATCH,FEND,HAPDIF, FNODE, FBSEARCH and FSITE macros
    //readTCS is now irrelevant but I kept it in there
    //read below for intructions

    //specify
    //setoptions(maxwhile:30000)
    //setoptions(maxwhile:30000)
    //addmacrofile("TCSmap6.mac") or name of this macrofile (needs to end in .mac)
    //run by aa<-fTCS(name of logfile,name of graph file,name for output graph)
    //i.e. aa<-fTCS("c1t45.txt.graph.log","c1t45s8.txt.graph","rs1t45s8.txt.graph")
    //if have dif numberical names for sites, the can add vector of names after other 3 entries
    //if not, then it will default to run(1,#sites)

 
//    fTCS         MACRO DOLLARS
    public static void fTCS(String [] siteNames, Vector realtaxa, int nsteps, ArrayList edges, int numHapHap, int numHapInt) {
    //macro to combine all other macros to map characters in TCS from TCS log and graph info
    //uses rdTCS TCSnode, DIFSUM, FPATH, DIFIN, FASSIGN, FMATCH,FEND,HAPDIF, FNODE, FBSEARCH and FSITE macros

    //INPUT
    //$1=TCS log file name (i.e. "c1t45.txt.graph.log")
    //$2=TCS graphfile (i.e. "c1t45s8.txt.graph")
    //$3=name you want for output graphfile (i.e. "rs1t45s8.txt.graph")
    //$4=OPTIONAL vector of numerical names for sites, if not then it
    //...defaults and uses run(1,#sites)
        
        
//    @rdTCSout<-rdTCS(($1),($2))
    /*rdTCSout = //OUTPUT structure
        //[1]=(@names) char vector of unique hap names after collapsed by TCS 
        //[2]=(@seqs) char matrix of seqs cols=sites, rows correspond to [1] 
        //[3]=(@seqcount) vector or counts for each hap in [1] this is how many seqs 
        //....were collapsed together for each unique hap, if you want to know
        //....which look in the log file to see
        //[4]=(@res1<-vector(@nsites,@nsteps,@nseqs,@tnseq))
        //....vector(#sites,#steps used in TCS,#seqs after collapse,#seqs originally)
        //[5]=(@hapnames) run(1,#unique seqs) this is now the new hapnames  (i.e seqfile[1]) which 
        //....is actually reference to row# in @names and @seqs so can maintain charnames for seqs
        //[6]=(nodeID)(@fill) matrix c1=(internal=0,hap=1),c2=hap/Internal name, c3=associated node name
        //....originally output [1] for original readTCS
        //....NOTE:  the hapname c2 now is the number of the row it matches in @names
        //....and the row number for that sequence
        //[7]=(edges) (@res) matrix with rows for each edge(branch) c1=sourcenodename,c2=targetnodename
        //....//long vector with all sources (1-n)first then targets(1-n) after (above is made in TCSnode)
        //[8]=first half of graph file (all nodes) to be later connected with bottom part of graph
        //....that is made in fend[1](labelled branch sites and bases) or fend[2](just sites)
*/
    //INPUT
    //$1=log file hap=node relations
    //$2=branchs from graph file
    //$3=structure with hapnames,seqs,sites
    //$4=number of steps in TCS analysis
    //OUTPUT
//    Vector nodeID = new Vector(); // = @rdTCSout[6]
//    Edge [] edges = new Edge[numEdges]; // = @rdTCSout[7]
    
    //uses sites vector provided, otherwise default is siteNum (starting at 1)
        int numSites = ((TaxaItem)realtaxa.get(0)).characters.length;
    if (siteNames == null) {
    } else {
        siteNames = new String[numSites];
        for (int i = 1; i <= numSites; i++ ) {
            siteNames[i] = ""+i;
        }
    }
    // @ denotes a temporary variable...
//    @seqfile<-structure(@rdTCSout[5],@rdTCSout[2],siteNames)
    
//    int nsteps; //<-(@rdTCSout[4][2]) // number of steps used...
//    @tcsout<-TCSnode(@nodeID,@edges)
//outputs for each branch(edge) the source and target nodename,hap or internal type, hapname,finally branch#
//matrix(c1=branch#,c2=source hapname,c3=targethapname,c4=source hap(1) or internal(0),c5=target hap(1) or internal(0)
// c6=(0=2Internal,1=1internal&1hap,2=2haps),c7=source nodename,c8=target nodename)
    int nbr =  edges.size(); // total number of edges?
//    @nbr<-dim(@tcsout)[1]
//    @dol<-unique(@tcsout[,6])
//    int numHapHap; // number of edges from hap-hap
//    int numHapInt; // number of edges from hap-internal
    
    int doi = 5;     //doi=whether run hap-hap and/or hap-int runs
    if(numHapHap > 0 && numHapInt > 0) {     //if both hap-hap and internal nodes then doi=1
        doi = 1;
    } else	
    if (numHapHap == nbr) {     //if only hap-hap then doi=2
        doi = 2;
    } else
    if (numHapInt == nbr) {     //if only hap-int then doi=3
        doi = 3;
    }
    
    if(doi<3) {
        difsum(edges);
//        @difsumout<-difsum(@seqfile[1],@seqfile[2],@seqfile[3],@tcsout);
    }
    ArrayList pseudoedges = new ArrayList();
    if(doi != 2){ // if there are some internal nodes...
        Object [][] fpathout = fpath(edges,nsteps,10, numHapInt); //OPTIONAL $3= max number of connections at any internal node for FNODE macro default=7 if not stated
        //        @fpathout<-fpath(@tcsout[@tcsout[,6]<2,],@nsteps,10);
        LWEdge [] edgearray = new LWEdge[0];
        edgearray = (LWEdge[])edges.toArray(edgearray);
        
        difin(edgearray, fpathout, pseudoedges); // stuff was stored in pseudoedges...
        LWEdge [] pedgearray = new LWEdge[0];
        pedgearray = (LWEdge[])pseudoedges.toArray(pedgearray);
        fassign(pedgearray,fpathout,edgearray);
        /*@difinout<-difin(@seqfile[1],@seqfile[2],@seqfile[3],@fpathout);
        @fsignout<-fassign(@difinout,@fpathout,@tcsout[,vector(1,6)]);*/
        
    }


    /*if(doi == 1){ // if we have haphap and hapint
        @fmatchout<-fmatch(doi,nbr,@difsumout,@fsignout);
    } else 
        if(doi==2){ // if there are only haphaps
            @fmatchout<-fmatch(doi,nbr,@difsumout)
        }
        else 
            if(doi==3) {    // if there are only hap-ints
                @fmatchout<-fmatch(doi,nbr,@fsignout);
            }

    @fsiteout<-fsite(@fmatchout[1],@seqfile[3]);


    @fendout<-fend(@tcsout,@fmatchout)

    //makes graph file vector
    //it defaults using the labeling of just sites (fendout[2])
    //if want labelled with "branch//!site//ihapnamebases" then change to fendout[1]
    //automatically spits out the file using the output name specified in ($3)
    @output<-vector(@rdTCSout[8],@fendout[2])
    matwrite(($3),@output,header:F)

    @results<-structure(@rdTCSout,@tcsout,@difsumout,@fpathout,@difinout,@fsignout,@fmatchout,@fsiteout,@fendout,@do)
    delete(@tcsout,@difsumout,@fpathout,@difinout,@fsignout,@fmatchout,@dol,@do,@fendout)
    delete(@nodeID,@edges,@seqfile,@nsteps,@nbr)
    delete(@results,return:T)
//    %fTCS%
*/    
}

/*    
//    rdTCS         
    public void rdTCS() {

    //macro to read TCS log file and graphfile
    //gets seqnames[1](char vec not sent on),seq matrix [2],counts[3],#sites[4][1],#steps[4][2]
    //..#seqs in graph[4][3],#seqs in nexus file before collapse[4][4]
    //hapnames (sent on, refers to seqnames[1]),nodeID[6],edges[7],#first half of graphfile[8]
    //takes place of readTCS, integrated into fTCS, no longer option to change hapnames
    //INPUT
    //$1=TCS log file name (i.e. c1t45.txt.graph.log)
    //$2=TCS graphfile (i.e. c1t45s8.txt.graph)


    //OUTPUT structure
    //[1]=(@names) char vector or unique hap names after collapsed by TCS 
    //[2]=(@seqs) char matrix of seqs cols=sites, rows correspond to [1] 
    //[3]=(@seqcount) vector or counts for each hap in [1] this is how many seqs 
    //....were collapsed together for each unique hap, if you want to know
    //....which look in the log file to see
    //[4]=(@res1<-vector(@nsites,@nsteps,@nseqs,@tnseq))
    //....vector(//sites,//steps used in TCS,//seqs after collapse,//seqs originally)
    //[5]=(@hapnames) run(1,//unique seqs) this is now the new hapnames  (i.e seqfile[1]) which 
    //....is actually reference to row// in @names and @seqs so can maintain charnames for seqs
    //[6]=(nodeID)(@fill) matrix c1=(internal=0,hap=1),c2=hap/Internal name, c3=associated node name
    //....originally output [1] for original readTCS
    //....NOTE:  the hapname c2 now is the number of the row for it matches in @names
    //....and the row number for that sequence
    //[7]=(edges) (@res) matrix with rows for each edge(branch) c1=sourcenodename,c2=targetnodename
    //....//long vector with all sources (1-n)first then targets(1-n) after (above is made in TCSnode)
    //[8]=first half of graph file (all nodes) to be later connected with bottom part of graph
    //....that is made in fend[1](labelled branch sites and bases) or fend[2](just sites)
    //THIS IS THE FINAL SET AT END TO RETURN BACK
    //@res1<-vector(@nsites,@nsteps,@nseqs,@tnseq)
    //@results<-structure(@names,@seqs,@seqcount,@res1,@hapnames,@fill,@res,@grf)
    //delete(@results,return:T)

    //take log file as lines
    @loglin<-vecread(($1),bylines:T,silent:T)
    //takes graph file by lines
    @graphf<-vecread(($2),bylines:T,silent:T)
    //tot seqs input into TCS includes all that may collapse
    @tnseq<-evaluate(vecread(string:@loglin[5],bywords:T)[4])
    // //of sites
    @nsites<-evaluate(vecread(string:@loglin[6],bywords:T)[4])
    @loglin<-@loglin[run(8,dim(@loglin)[1])]
    //mat c1=hapname, c2=full seq as on unspaced character
    @tnameseq<-matrix(rep("x",@tnseq*2),@tnseq)
    //gets names and seqs from loglin
    @i<-0
    @j<-1
    while(@i<@tnseq){@i<-@i+1
    @tnameseq[@i,1]<-vecread(string:@loglin[@j],bywords:T)[2]
    @j<-@j+1
    @tnameseq[@i,2]<-@loglin[@j]
    @j<-@j+1
    };;

    //..//steps set or use for TCS run
    @login<-@loglin[run(@j,dim(@loglin)[1])]
    @tt<-run(1,dim(@loglin)[1])[@loglin=="RUN SETTINGS"]
    @tc<-vecread(string:@loglin[@tt+1],bywords:T)
    @nsteps<-evaluate(@tc[dim(@tc)[1]])

    //..//unique seqs after collapsing done by TCS
    @tt<-run(1,dim(@loglin)[1])[@loglin=="HAPLOTYPES"]
    @tc<-vecread(string:@loglin[@tt+1],bywords:T)
    @nseqs<-evaluate(@tc[dim(@tc)[1]])


    //set loglin to start at first row of haplotype list
    @tt<-run(1,dim(@loglin)[1])[@loglin=="Haplotype list:"]
    @loglin<-@loglin[run(@tt+3,dim(@loglin)[1])]

    //names are names of the unique seqs after collapsing
    @names<-rep("x",@nseqs)
    //this is number of seqs that collapsed into this seq, rows correspond
    //to rows of names
    @seqcount<-rep(0,@nseqs)
    @i<-0
    while(@i<@nseqs){@i<-@i+1
    @names[@i]<-vecread(string:@loglin[@i],bywords:T)[2]
    @seqcount[@i]<-dim(vecread(string:@loglin[@i],bywords:T))-2
    };;

    //pulls out seqs from @tnameseq that correspond to the unique seqs in @names
    @seqs<-rep("x",@nseqs)
    @i<-0
    while(@i<@nseqs){@i<-@i+1
    @seqs[@i]<-@tnameseq[@tnameseq[,1]==@names[@i],2]
    if(@i==1){
    @tempseq<-vecread(string:@seqs[@i],bychars:T)'}else{
    @tempseq<-vconcat(@tempseq,vecread(string:@seqs[@i],bychars:T)')
    };;
    };;


    @seqs<-@tempseq
    delete(@tempseq)


    //start the log part of original readTCS instead use rest of @loglin

    //this make fill c1=(internal=0,hap=1),c2=hap/Internal name, c3=associated node name
    //for haplotype c1=1, the hapname(c2) is the row number for the equivalent haplotype
    //found in @names, this makes it so any char name can be used for seqs
    //which also corresponds to the row number of the for the seq in seqs 
    //this means at the end that hap names in fpaths are actually the row of that seq in @names

    @logf<-vecread(string:@loglin,bywords:T,silent:T)
    //makes logf from "Here" to corrections that localizes it to the graph
    @a<-vector(run(1,dim(@logf))[@logf=="Here"],run(1,dim(@logf))[@logf=="Calculations"])
    @logf<-@logf[run(@a[1],@a[2])]

    //this finds words that have "[" in it excludes all other words so just have haps and nodes
    @tk<-hconcat(run(1,dim(@logf)[1]),rep(0,dim(@logf)[1]))
    @j<-0
    while(@j<dim(@logf)[1]){@j<-@j+1
    @tkl<-vecread(string:@logf[@j],bychars:T)
    if(sum(vector(@tkl=="["))>0){@tk[@j,2]<-1}
    };;

    //logf now only has lines like "h22[21]:"
    @logf<-@logf[@tk[,2]==1]

    delete(@tk,@tkl)



    @fill<-matrix(rep(-1,dim(@logf)[1]*3),dim(@logf))
    @j<-0
    while(@j<dim(@logf)[1]){@j<-@j+1
    @tp<-vecread(string:@logf[@j],bychars:T)
    @brac<-run(1,dim(@tp))[@tp=="["||@tp=="]"]
    if(sum(@tp[run(1,2)]==vector("I","n"))==2){
    @fill[@j,1]<-0
    @fill[@j,2]<-evaluate(paste(@tp[run(3,@brac[1]-1)],sep:""))
    @fill[@j,3]<-evaluate(paste(@tp[run(@brac[1]+1,@brac[2]-1)],sep:""))
    }else{
    @fill[@j,1]<-1
    @fill[@j,2]<-run(1,@nseqs)[@names==paste(@tp[run(1,@brac[1]-1)],sep:"")]
    @fill[@j,3]<-evaluate(paste(@tp[run(@brac[1]+1,@brac[2]-1)],sep:""))
    };; //end if
    };; //end j loop

    //this is now the new hapnames  (i.e seqfile[1]) which is actually 
    //reference to row// in @names and @seqs so can maintain charnames for seqs
    @hapnames<-run(1,@nseqs)

    //this is the start of manipulating the graph file
    @bb<-run(1,dim(@graphf))[@graphf=="   edge ["]
    //grf is first part of graph
    @grf<-@graphf[run(1,@bb[1]-1)]
    @graphf<-vecread(string:@graphf,bywords:T)

    //sorts through graph file to get node names of source and targets for each edge
    @b<-run(1,dim(@graphf))[@graphf=="edge"]
    @graphf<-@graphf[run(@b[1],dim(@graphf))]
    @c<-run(1,dim(@graphf))[@graphf=="source"]
    @cc<-run(1,dim(@graphf))[@graphf=="target"]
    @source<-@graphf[@c+1]
    @target<-@graphf[@cc+1]
    @com<-vector(@source,@target)
    @res<-rep(0,dim(@com))
    @i<-0
    while(@i<dim(@com)[1]){@i<-@i+1
    @res[@i]<-evaluate(@com[@i])
    };; //end i loop

    //figure out how to incorporate what readTCS does
    //figure out seqfile[1]=name
    //seqfile[2]=seqs
    //seqfile[3]=sites (should) be run(1,nsites) by default or user imput)
    //make proxy number IDs for haps then reference back to at end
    //have user supply output graphfile name
    //optional input of site //'s
    //readTCSoutput used for input of fTCS
    //...nodeID,edges

    @res1<-vector(@nsites,@nsteps,@nseqs,@tnseq)
    @results<-structure(@names,@seqs,@seqcount,@res1,@hapnames,@fill,@res,@grf)
    delete(@loglin,@graphf,@tnseq,@nsites,@tnameseq,@i,@j,@nsteps,@nseqs,@names,@seqcount)
    delete(@seqs,@logf,@a,@fill,@tp,@brac,@bb,@grf,@b,@c,@cc,@source,@target)
    delete(@com,@res,@res1)
    delete(@results,return:T)
    }*/

/**
 *     outputs for each branch(edge) the source and target nodename,hap or internal type, hapname,finally branch#
    matrix(c1=branch#,c2=source hapname,c3=targethapname,c4=source hap(1) or internal(0),c5=target hap(1) or internal(0)
     c6=(0=2Internal,1=1internal&1hap,2=2haps),c7=source nodename,c8=target nodename)
 */
/*    public void TCSnode  ()    {

    //uses $1 & $2 in PATHALL macro
    //output is sent to FPATH/FNODE, DIFSUM/HAPDIF, FASSIGN/FBSEARCH, and FMATCH macros,
    //macro to match hapsnames to nodenames from a TCS graph and logfile
    //can use this output with DIFSUM & HAPDIF macros to determine sites and bases on each branch
    //INPUT
    //$1=comes from end of logfile that identifies hapname(or Internal node) with nodename
        //these nodenames are used for the branchs(edges) in the graph
        //matrix(c1= vector with 1's for hap, 0's for internal node (In)
               //c2= vector hapnames 
               //NOTE if haps have extra digit that is one then nodeID[nodeID[,1]==1,2]<-(nodeID[nodeID[,1]==1,2]-1)/10 
               //c3=nodenames
    //$2=comes from edges at end of graph file
        //long vector with all sources (1-n)first then targets(1-n) after
    //OUTPUT
    //outputs for each branch(edge) the source and target nodename,hap or internal type, hapname,finally branch#
    //matrix(c1=branch#,c2=source hapname,c3=targethapname,c4=source hap(1)/internal(0),c5=target hap(1)/internal(0)
           //c6=(0=2Internal,1=1internal&1hap,2=2haps),c7=source nodename,c8=target nodename)
    @nodeID<-($1)
    @edges<-($2)
    @nodeID<-hconcat(@nodeID,run(1,dim(@nodeID)[1]))
    @edges<-hconcat(@edges,rep(0,dim(@edges)[1]),rep(0,dim(@edges)[1]),run(1,dim(@edges)[1]))
    @nodeID<-@nodeID[grade(@nodeID[,3]),]
    @edges<-@edges[grade(@edges[,1]),]
    @numnode<-dim(@nodeID)[1]
    @numedge<-dim(@edges)[1]/2
    @k<-1
    @i<-0
    while(@i<@numedge*2){@i<-@i+1
    @j<-@k-1
    while(@j<@numnode){@j<-@j+1
    if(@edges[@i,1]==@nodeID[@j,3]){@edges[@i,run(2,3)]<-@nodeID[@j,run(1,2)]
    @k<-@j
    @j<-@numnode
    };;
    };;};;
    @edges<-@edges[grade(@edges[,4]),]
    @br<-hconcat(@edges[run(1,@numedge),run(1,3)],@edges[run(@numedge+1,@numedge*2),run(1,3)],run(1,@numedge))
    @add<-sum(@br[,vector(2,5)]')'
    @branch<-hconcat(@br[,vector(7,3,6,2,5)],@add,@br[,vector(1,4)])
    delete(@nodeID,@edges,@numnode,@numedge,@k,@i,@j,@br,@add)
    delete(@branch,return:T)
//    %TCSnode%
    }
*/
    
    public static void difsum(ArrayList edges) {

    //uses:  output from TCSnode output and hapname, seqs, sites ($3) from PATHALL
    //to take results from TCSnode macro and uses HAPDIF macro to determine
    //and report site differences at branches first at branches between two haps
    //sends to FMATCH
    //INPUT
    //$1-$3 are inputs for hapdif macro and $4 contains some for hapdif macro
    //$1=vector of hap labels corresponding to rows of $2 seq matrix
    //$2=matrix of seqs corresponding to $1 hap labels
    //$3=vector of sites nums corresponding to columns of $2 seq matrix
    //$4=matrix from TCSnode: //outputs for each branch(edge) the source and target nodename,
      //hap or internal type, hapname,finally branch#
       //matrix(c1=branch//,c2=source hapname,c3=targethapname,c4=source hap(1)/internal(0),c5=target hap(1)/internal(0)
           //c6=(0=2Internal,1=1internal&1hap,2=2haps),c7=source nodename,c8=target nodename)   
    //OUTPUT structure
    //[1] c1=branch# corresponding to TcSnode output
    //....c2=set as 2 to designate hap-hap
    //....c3=the site difference between the haps at that branch 
    //....c4=hap name for first hap in branch
    //....rows for each branch
    //[2] matrix c1=source bases,c2=targetbases,rows correspond to rows of [1]matrix

    /*@hapnam<-($1)
    @seq<-($2)
    @site<-($3)
    @branch<-($4)
*/    
//    @branch1<-@branch[@branch[,6]==2,] // get all edges that are HapHap
//    num<-dim(@branch1)[1] // the number of HapHap edges
    int num = edges.size(); // used all edges...
//    @difmat<-matrix(rep(0,@num*4),@num) // a difference matrix, zeroed out, with 4xnumHapHap
    
    int i = 0;
    while(i<num) {
        i++;
        LWEdge edge = (LWEdge)edges.get(i-1); // actually need to make sure this edge is a HapHap edge
        if (edge.type == LWEdge.HAPHAP)
            hapdif(edge);
        // I will keep track of the 5 bits of info below in the LWEdge object...
        /*if(i==1) { // first one done...
            //          $4=vector with pair of haps to compare
//            @bb<-hapdif(@hapnam,@seq,@site,@branch1[@i,run(2,3)]) // returns the sites that differ between the two haplotypes compared
            
            hapdif(edges,siteNames,edge);
            @difmat[@i,1]<-@branch1[@i,1] // get branch# and assign it to this difmat [i][1]
    @difmat[@i,2]<-2 // set difmat[i][2] = 2
    @difmat[@i,3]<-@bb[1] // set difmat[i][3] to the vector of seq differences
    @difmat[@i,4]<-@branch1[@i,2] // set difmat[i][4] to the source hapname
    @bases<-@bb[2]' // set bases to be a [2]=matrix with rows for each site that differs, c1=base for haps[1],c2=base for hap2 (the transpose, so row 1 is haps1
//    delete(@bb)
    } else {
    @bb<-hapdif(@hapnam,@seq,@site,@branch1[@i,run(2,3)])
    @difmat[@i,1]<-@branch1[@i,1]
    @difmat[@i,2]<-2
    @difmat[@i,3]<-@bb[1]
    @difmat[@i,4]<-@branch1[@i,2]
    @bases<-hconcat(@bases,@bb[2]') // ' is the matrix transpose and hconcat is a matrix concat (rows to rows...)
//    delete(@bb)
    }*/
    }
//    @results<-structure(@difmat,@bases')
//    delete(@hapnam,@seq,@site,@branch,@num,@i,@difmat,@bases)
//    delete(@results,return:T)
//    %difsum%
    }

    public static void hapdif(LWEdge edge) {
    //used in DIFSUM macro
    //macro to find and report differences between haplotypes
    //will spit out site number, and bases for each hap at that site
    //INPUT
    //$1=vector of hap labels corresponding to rows of $2 seq matrix
    //$2=matrix of seqs corresponding to $1 hap labels
    //$3=vector of sites nums corresponding to columns of $2 seq matrix
    //$4=vector with pair of haps to compare
    //OUTPUT
    //structure of
    //[1]=vector of site or sites differing between the haps
    //[2]=matrix with rows for each site that differs, c1=base for haps[1],c2=base for hap2
    
        
        
        // my interpretation:
        // for each site, if they are different (and not ? or . or ambig) add to edge.differences.add(new Integer(siteNum));
        for (int siteNum = 0; siteNum < edge.source.characters.length; siteNum++) {
            if (edge.source.characters[siteNum] != '?' && edge.dest.characters[siteNum] != '?' &&
                    edge.source.characters[siteNum] != edge.dest.characters[siteNum]) { //FIXME NOTE only checking for ?, not checking case, etc.
                
                	edge.differences.add(new Integer(siteNum));
            }
        }
        
/*    @hapname<-($1)
    @seqs<-($2)
    @sites<-($3)
    @haps<-($4)
    @isites<-run(1,dim(@sites)[1])
    @hapname<-hconcat(run(1,dim(@hapname)[1]),@hapname)
    @haprow<-vector(0,0)
    @i<-0
    @k<-0
    while(@i<2){@i<-@i+1
    @j<-0
    while(@j<dim(@hapname)[1]){@j<-@j+1
    if(@haps[@i]==@hapname[@j,2]){@haprow[@i]<-@hapname[@j,1]
    @k<-@k+1
    @j<-dim(@hapname)[1]
    };;
    };;};;
    @pair<-@seqs[@haprow,]'
    @diffs<-@isites[@pair[,1]!=@pair[,2]]
    @bases<-@pair[@diffs,]
    @rdiffs<-@sites[@diffs]

    //this takes diffs founds and for ks, kb finds all diffs not involving "?"
    //these are not used but just keep in here in case want to bring it in
    //could write conditional to give all diffs, only diffs without "?", or
    //only diffs exluding "?" and any ambiguities (only involving A,G,T,C)
    //will set for the last conclusion (@rs and @rb)

    @temp<-structure(@rdiffs,@bases)
    @snum<-run(1,dim(@temp[1])[1])
    //k3 is list of all excluded sites
    @k4<-rep(1,dim(@snum)[1])

    if(sum(vector(@temp[2][,1]=="?"))>0||sum(vector(@temp[2][,2]=="?"))>0){
    @k1<-@snum[@temp[2][,1]=="?"]
    @k2<-@snum[@temp[2][,2]=="?"]
    @k3<-sort(unique(vector(@k1,@k2)))
    @k4[@k3]<-0
    delete(@k1,@k2,@k3)
    }

    //k5 is list of included columns (don't have ? in it)
    @k5<-@snum[@k4==1]
    //actual site //
    @ks<-@temp[1][@k5]
    //bases for the two
    @kb<-@temp[2][@k5,]
    @kn<-dim(@ks)[1]

    @r1<-matrix(rep(0,dim(@snum)[1]*2),dim(@snum)[1])
    @r1[@temp[2][,1]=="A"||@temp[2][,1]=="C"||@temp[2][,1]=="G"||@temp[2][,1]=="T",1]<-1
    @r1[@temp[2][,2]=="A"||@temp[2][,2]=="C"||@temp[2][,2]=="G"||@temp[2][,2]=="T",2]<-1
    @r2<-sum(@r1')'
    @rs<-@temp[1][@r2==2]
    @rb<-@temp[2][@r2==2,]

    @results<-structure(@rs,@rb)
    delete(@hapname,@seqs,@sites,@haps,@isites,@haprow,@i,@j,@pair,@diffs,@rdiffs,@bases)
    delete(@temp,@snum,@k4,@k5,@ks,@kb,@kn,@r1,@r2,@rs,@rb)
    delete(@results,return:T)*/
    }

    public static Object [][] fpath (ArrayList edges,int nsteps,int maxIntCon, int numHapInt) {

    //uses FNODE macro and part of output from TCSNODE macro (!=hap-hap), and ($4 step length)
    //send to: DIFIN and FASSIGN macros
    //macro to find all paths in network between haps that have internal nodes between them
    //it starts with all branches from TCSNODE output with only hap-internal and 
    //internal-internal branches (i.e. branch[branch[,6]<2,])
    //it makes a path for each branch with hap-internal connections
    //this path contains the first branch name, the side the hap is on, the name of that hap 
    //then the internal node it is connected to.  

    //The next rounds takes a path's node and uses 
    //FNODE to find all other branches with that node and makes an updated path with branch and side
    //added next to the first branch and side, 
    // if it ends in a hap the last hapname is attached and the
    //node is called -1, if it ends in another node then that node replaces the prior node and the next path
    //is moved too. 
        
    //It runs through each path at that step until they are all extended then moves to the next
    //round.  It skips all paths labeled -1, just re-adding them.  
        
    //It goes until all paths have -1 label meaning
    //all branches in the path are found and they end in a hap.

    //it then goes through all paths and eliminates redundancy (each path will have its mirror image
    //i.e. hap1-hap2==hap2-hap1).
    //spits out a matrix columns= unique paths, (dim(paths)[1]/2)-1=MAX number branches in any path
    //the first MAX rows are the branches in the path in order (-1's are filler)
    //the next MAX rows are the corresponding sides (7==source,8==target) 1st node/hap in path starting with 1st hap
    //the last two rows are the two haps at each end of the path

    //INPUT
    //$1=takes matrix from TCSnode output (i.e. branch) for
       //all branches with hap-int or int-int (without hap-hap branches (i.e. branch[branch[,6]<2,]))
       //matrix(c1=branch//,c2=source hapname,c3=targethapname,
              //c4=source hap(1)/internal(0),c5=target hap(1)/internal(0)
              //c6=(0=2Internal,1=1internal&1hap,2=2haps),c7=source nodename,c8=target nodename)
    //$2=step length from TCS (it takes this ($2*2)+1 to make sure long enough for all paths)
    //OPTIONAL $3= max number of connections at any internal node for FNODE macro default=7 if not stated

    //OUTPUT 
    //spits out a matrix columns= unique paths, (dim(paths)[1]/2)-1=MAX number branches in any path
    //the first MAX rows are the branches in the path in order (-1's are filler)
    //the next MAX rows are the corresponding sides (7==source,8==target) 1st node/hap in path starting with 1st hap
    //the last two rows are the two haps at each end of the path

        //FIXME need to make sure that we skip over those edges that are HapHap!
    
    int bmax = nsteps*2+1;
    int lim = maxIntCon;
    int tot = (bmax*2)+3;
    Object [][] paths = new Object[tot][numHapInt];
    int numPaths = 0;

    int count = 0;
    int m = 0; 
    int numNonHapEdges = edges.size();
    while(count < numNonHapEdges) {
        count++;
        LWEdge edge = (LWEdge)edges.get(count-1);
        if(edge.type == LWEdge.HAPINT) { // IntHap
            m++;
            
            paths[0][m-1] = edge; // first element should be set to the branch#
            if(!edge.source.isIntermediate) {  // is source hap (1)? or internal (0)
                paths[bmax*2][m-1] = edge.source; // FIXME  careful of off by one!  set to source hapname
                paths[bmax][m-1] = new Integer(7);
                paths[(bmax*2)+2][m-1] = edge.dest; // target nodename
            } else {
                paths[(bmax*2)][m-1] = edge.dest; // target hap name
                paths[bmax][m-1] = new Integer(8);
                paths[(bmax*2)+2][m-1] = edge.source; // source nodename
            }
        }
    }
	
    // hmm, looks like it cuts off the first blank set of -1 original path and the total length? dim[1] = 57 [2] = 9
    // I never added the first blank col, so no need to remove it...
    // remove the first column...
	    int n = 0;
	    int nn = 0;

	    while(nn == 0) {
	        n++;
	        ArrayList begin = new ArrayList(); // set to -1 to start?  or just don't initialize?
	        // this will be the list of columns
	        int p = 0;
	        while(p < paths[0].length) { // is this the right boundary? p is a column...
	     
	            p++;
	            
	            if(paths [tot-1][p-1] != null) {
	                Object[][] cons = fnode((LWEdge)(paths[n-1][p-1]),(TaxaItem)(paths[tot-1][p-1]),edges,lim);
	                
	                int q = 0;
	                while(q < lim) { // what about the end of this? 
	                    q++;
	                    while(cons[q-1][2] == null) { // skip over the irrelevant ones...// problem is, this is supposed to be sorted?
	                        q++;
	                    }
	                    Object [] temp = new Object[tot]; // the column at p-1
	                    for (int row = 0; row < paths.length; row++) {
	                        temp[row] = paths[row][p-1];
	                    }

	                    temp[n] = cons[q-1][0];
	                    temp[bmax+n] = cons[q-1][1];
	                    if (((Integer)cons[q-1][2]).intValue() == 0) { // internal-internal
	                        temp[tot-1] = cons[q-1][4];

	                    } else 
	                        if(((Integer)cons[q-1][2]).intValue() == 1) { // internal-hap
	                            temp[tot-2] = cons[q-1][3];
	                            temp[tot-1] = null;
	                        }
	                    //makes sure it doesn't repeat a node in the run
	                    boolean repeat = false;
	                    for (int pathnum = 0; pathnum < n; pathnum++) {
	                        if (paths[pathnum][p-1] == cons[q-1][0]) {
	                            repeat = true;
	                            break;
	                        }
	                    }
	                    if (!repeat) {
	                        begin.add(temp); // this is actually adding temp (a column) to the end of begin...
	                    }
	                }
	            } else { //paths [tot-1][p-1] == null // this was done since we just overwrote paths, instead of creating a new matrix 
	                Object [] temp = new Object[tot]; // the column at p-1
                  for (int row = 0; row < paths.length; row++) {
                      temp[row] = paths[row][p-1];
                  }
	                begin.add(temp);
	            }
	        }
	        
	        // now set paths = begin (begin needs to be transposed...)
	        
	        int numCols = begin.size();
	        int numRows = tot;
	        paths = new Object[numRows][numCols];

	        for (int col = 0; col < numCols; col++) {
	            Object [] myCol = (Object[])begin.get(col);
	            for (int row = 0; row < numRows; row++) {
	                paths[row][col] = myCol[row]; 
	            }
	        }
	        boolean sum = false;
	        
	        for (int allpaths = 0; allpaths < paths[0].length; allpaths++) { //FIXME bounds?
	            if (paths[tot-1][allpaths] != null) {
	                sum = true;
	                break;
	                // take row tot-1, count up the number that are not== null (exclude repeats!)
	            }
	        }
	        if(!sum) { // if there are no paths == -1 
	            nn = 1; // get out of here...
	        }
	    }
	    
	    int sum = 0;
	    int most = 0;
	    
	    for (int allcols = 0; allcols < paths[0].length; allcols++) {
	        sum = 0;
	        for (int allrows = 0; allrows < bmax; allrows++) {
	            if (paths[allrows][allcols] != null) {
	                sum ++;
	        }
	        if (sum > most) {
	  	        most = sum;
	  	    }
	    }
	        
	        
	    }
	    // reset paths to be data from 0->most, bmax->bmax+most, tot-1->tot
	    int all = most*2+2;
	    Object [][] oldpaths = paths;
	    paths = new Object[all][];
	    for (int allpaths = 0; allpaths < most; allpaths++) {
	        paths[allpaths] = oldpaths[allpaths];
	        paths[most + allpaths] = oldpaths[allpaths+bmax];
	    }
	    paths[most*2] = oldpaths[tot-3];
	    paths[most*2+1] = oldpaths[tot-2];
	    oldpaths = null;

	    all = paths[0].length;
	    boolean [] dontkeep = new boolean[all]; // FIXME assumes all are false to start (they set to 1 so 1 == false)
	    
	    TaxaItem [] []haps = new TaxaItem[2][all];
	    
	    for (int iter = 0; iter < all; iter++) { // sorted by id?
	        haps[0][iter] = (((TaxaItem)paths[paths.length-2][iter]).id > ((TaxaItem)paths[paths.length-1][iter]).id)?((TaxaItem)paths[paths.length-1][iter]):((TaxaItem)paths[paths.length-2][iter]);
	        haps[1][iter] = (((TaxaItem)paths[paths.length-2][iter]).id > ((TaxaItem)paths[paths.length-1][iter]).id)?((TaxaItem)paths[paths.length-2][iter]):((TaxaItem)paths[paths.length-1][iter]);
	    }
	    int j = 0;
	    while(j < all) {
	        j++;
	        if(!dontkeep[j-1]) {
	            int k = j+1;
	            while(k < all) { 
	                k++;
	                if(!dontkeep[k-1]) {
	                    if (haps[0][j-1] == haps[0][k-1] && haps[1][j-1] == haps[1][k-1])
	                    {
	                        //if have same haps in path then keep path with fewers branches and discard other
	                        int first = 0;
	                        int second = 0;
	                        for (int f = 0; f < paths.length; f++) {
	                            if (paths[f][j-1] == null) {
	                                first ++;
	                            }
	                            if (paths[f][k-1] == null) {
	                                second ++;
	                            }
	                        }
	                        if (first < second) {
	                            dontkeep[j-1] = true;
	                        } else {
	                            dontkeep[k-1] = true;
	                        }
	                        

	                    }
	                }
	            }
	        }
	    }
	    int jj = 0;
	    while(jj < all) {
	        jj++;
	        if(haps[0][jj-1]==haps[1][jj-1]) { 
	            dontkeep[jj-1] = true;
	        }
	    }
	    
	    // remove from paths all columns where dontkeep == true
	    ArrayList []rows = new ArrayList[paths.length];
	    
	    int numK = 0;
	    for (int k = 0; k < dontkeep.length; k++) {
	        if (!dontkeep[k]) {
	            numK++;
	        }
	    }
	    //takes paths and make it size of max #branches in a paths*2+2
	    int blankrows =0;
	    Object [][] newpaths = new Object[paths.length][numK];
	    int cpath []= new int[paths.length]; // 
	    int keepcount = 0;
	    for (int keepers = 0; keepers < dontkeep.length; keepers++) {
	        //	        cpath[keepers] = -1; // the nonkeepers are initialized to -1, to skip later...
	        if (!dontkeep[keepers]) {
	            //            @cpath<-vector(sum(@paths'==-1)) // the total number of nulls in all of paths (keepers only)
	            for (int row = 0; row < paths.length; row++) {
	                newpaths[row][keepcount] = paths[row][keepers];
	                if (paths[row][keepers] == null) {
	                    cpath[row] ++;
	                    if (cpath[row] == numK) {
	                        newpaths[row] = null;
	                        blankrows++;
	                    }
	                }
	            }
	            keepcount++;
	        }
	    }
	    //	    paths = newpaths; // now remove the rows that have ccpath == #cols (in otherwords, all nulls)
	    paths = new Object[newpaths.length - blankrows][];
	    //	    blankrows = 0;
	    int currow = 0;
	    for (int ro = 0; ro < newpaths.length; ro++) {
	        if (newpaths[ro] != null) {
	            paths[currow++] = newpaths[ro];
	        }
	    }
	    
	    /*print2d(paths);
	    for (int cols = 0; cols < cpath.length; cols++) {
	        System.out.print(cpath[cols] +"\t");
	    }
	    System.out.println();*/
	    //	    paths = (Object [][])newpaths.toArray(paths);
	    
	    //	    @cpath<-vector(sum(@paths'==-1))
	    // vector from 1 to keepcount, where cpath[i] != paths[i].length
	    
	    //	    @ccpath<-vector(run(1,dim(@cpath)[1])[@cpath!=dim(@paths)[2]]) // took care of this above...
	    
	    //	    @paths<-@paths[@ccpath,]
	    //makes new matrix that will have 5 (-1 rows at end of branches and sides
	    //this will protect for paths where #diffs are > than #branches found (when TCS has it wrong)
	    //	    print2d(paths);
	    
	    int tdimp1 = paths.length;
	    int tdimp2 = paths[0].length;
	    //	    @tdimp<-dim(@paths)
	    //	    @tspot<-(@tdimp[1]-2)/2
	    int tspot = (tdimp1-2)/2;
	    // basically 1->tspot, a 5xtdimp2 set of -1's,@tspot+1->@tspot*2,another 5xtdimp2 set of -1's, and the last two...
	    Object [][] npaths = new Object[tdimp1+10][];
	    for (int pathcount = 0; pathcount < tspot; pathcount++) {
	        npaths[pathcount] = paths[pathcount];
	        npaths[tspot + pathcount + 5] = paths[pathcount+tspot];
	    }
	    // assign the blanks
	    for (int pathcount = 0; pathcount < 5; pathcount++) {
	        npaths[tspot + pathcount] = new Object[tdimp2];
	        npaths[2*tspot + pathcount + 5] = new Object[tdimp2];
	    }
	    // leave the other ones as null (the 5 after each set)
	    npaths[tdimp1 + 8] = paths[tdimp1-2];
	    npaths[tdimp1 + 9] = paths[tdimp1-1];
	    //@tpaths<-hconcat(@paths[run(1,@tspot),]',matrix(rep(-1,@tdimp[2]*5),@tdimp[2]),@paths[run(@tspot+1,@tspot*2),]',matrix(rep(-1,@tdimp[2]*5),@tdimp[2]),@paths[run(@tdimp[1]-1,@tdimp[1]),]')'
	    //	    @paths<-@tpaths
	    paths = npaths;

	    return paths;
    }

    public static void difin(LWEdge [] edges, Object[][] paths, ArrayList pseudoedges) {

	    //uses output from FPATH macro, and hapname,seqs,sites ($3 from PATHALL) uses HAPDIF
	    //sends to: FASSIGN
	    //determines sites that differ between haps in each path
	    //structure with 1 matrix with sites that differ in each path
	    //1 array with actual bases at each site for both sides of branch for each path
	    //
	    //INPUT
	    //$1-$3 are inputs for hapdif macro and $4 is output from FPATH macro
	    //$1=vector of hap labels corresponding to rows of $2 seq matrix
	    //$2=matrix of seqs corresponding to $1 hap labels
	    //$3=vector of sites nums corresponding to columns of $2 seq matrix
	    //$4=output from FPATH macro
	    //...this is matrix with columns=unique paths
	    //...matrix columns= unique paths, (dim(paths)[1]/2)-1=MAX number branches in 
	    //...any path the first MAX rows are the branches in the path in order 
	    //...(-1's are filler) the next MAX rows are the corresponding sides 
	    //...(7==source,8==target) 1st node/hap in path starting with 1st hap
	    //....the last two rows are the two haps at each end of the path
	    //
	    //OUTPUT
	    //structure
	    //[1]=matrix with columns for each path, rows are sites that differ in path (-1's are filler)
	    //....matrix(rep(-1,maxsteps*numpaths),maxsteps)
	    //[2]=array with bases for each hap at site for all site in path for all paths
	    //....array(rep("x",maxsteps*the two bases*numpaths),vector(maxsteps,the two bases,numpaths))

      
      // the hapnames, seqs, and sites are all available in edges...
        
       
	    int npaths = paths[0].length;
	    int bmax = paths.length/2-1;
	    int hapf = paths.length -1;
	    Object[][] calls = new Object[bmax][npaths];
	    
	    //	    @calls<-matrix(rep(-1,@bmax*@npaths),@bmax)
	    // the bases exist in the edges 
	    //	    @bases<-array(rep("x",@bmax*2*@npaths),vector(@bmax,2,@npaths))
	    int h = 0;
	    //	    @h<-0
	    while(h < npaths){
	        //	        @h<-@h+1
	        h++;
	        //	        bb  = hapdif(@hapnam,@seq,@site,@paths[run(@hapf,@hapf+1),@h])
	        TaxaItem o1 = (TaxaItem)paths[hapf-1][h-1];
	        TaxaItem o2 = (TaxaItem)paths[hapf][h-1];
//	        System.out.println(o1.name + " " + o2.name);
	        LWEdge pseudoedge = new LWEdge(o1,o2,LWEdge.HAPHAP,edges.length+pseudoedges.size()); // FIXME does the source/dest matter here? what about the type?
	        pseudoedges.add(pseudoedge);
	        hapdif(pseudoedge);
	        
	        /*@calls[run(1,dim(@bb[1])),@h]<-@bb[1]
	        @bases[run(1,dim(@bb[1])),,@h]<-@bb[2]*/
	    }
	    /*@results<-structure(@calls,@bases)
	    delete(@hapnam,@seq,@site,@paths,@npaths,@bmax,@hapf,@calls,@bases,@h)
	    delete(@results,return:T)*/
	    //        return calls;
    }
    public static void print1d(Object [] array) {
        for (int col = 0; col < array.length; col++) {
            System.out.print( array[col] +"\t");
        }
        System.out.println();
    }
    public static void print1d(int [] array) {
        for (int col = 0; col < array.length; col++) {
            System.out.print( array[col] +"\t");
        }
        System.out.println();
    }
    public static void fassign (LWEdge[] pseudoedges,Object [][]paths,LWEdge[] edges){

    
    //uses output from DIFIN, FPATH macros, and TCSnode output[,vector(1,6)], uses FBSEARCH within
    //sends to FMATCH
    //macro to assign sites to each branch that is hap-int or int-int (hap-hap branches are resolved in DIFSUM)
    //it does this by using paths (branches,sides,haps for paths come from FPATH macro,
    //and sites and bases for paths come from DIFIN macro

        
    // 1) from the matrix of all branches it picks a hap-int or int-int branch and
    //finds all paths that contain it among all paths:
        //        where #sites==3branches
        
    // 2) it finds all shared sites among all paths that contain that branch,
        // a) if there is
        	//only one site then it defines that branch with that site and bases,
        
    // 3) it then finds branches where mulitiple branches are all only on one shared path, it then distributes
    //the sites in that path to the branches on that path
        
    // 4) then it finds branches shared together on multiple paths with a subset of shared sites and assigns those
        
    // 5) finally if more than one shared site and branch in all paths, it the searches for next branch,
        // if defined then
        	// a) it defines that branch, 
        	// b) removes that site and branch from consideration, 
        	// c) finishes all of those extra branches until only
        		//one is left or all are left defining the last branch or all unsolved branches shared on all paths are arbitrarily
        		//assigned the remaining sites.
        
    //it outputs 
    //NOTES:  when using FBSEARCH, if that branch is not found in the paths where #br=#sites
    //........then FBSEARCH reports 0, if that happens it skips that branch
    //at end of FASSIGN is summarily takes all branches where branch[i,2] still = 0
    //and calls it 7 and make the site (branch[i,3]<--1) more info may be able to be taken from
    //branches where #br!=#sites but am not trying right now.


    //INPUT
    //$1=output from DIFIN macro (struture[1]=matrix of sites for paths,[2]=array of corresponding bases
    //$2=output from FPATH (matrix with branch,sides,and haps for each path (dim(paths)[1]/2)-1=max//steps)
    //$3=matrix with ALL branches in order c1=branch names, c2=(hap-hap(2),hap-int(1),int-int(0))
    //...(ex. TCSoutput[,vector(1,6)])
    //OUTPUT
    //results<-structure(branch,rpaths,rbrsite,allpaths,allsites,allsides,allbases,allhaps,bransite,res1)
    //[1]=matrix rows=branches,c1=branch#,c2= hap-hap(2) 1=found site for,c3=site for branch
    //[2]=cols for each path, rows list of paths that contain this branch -1's filler
    //[3]=array(c1=other branches shared with this site across shared paths,c2=shared site/sites, for each path)
    //[4]-[9] are all ordered with #nequal paths have #br=#sites, the last ones are not equal
    //[4]=allpaths, [5]=allsites, [6]=allsides, [7]=allbases, [8]=allhaps
    //[9]=mat c1=#branches in path, c2=#sites in path
    //[10]=res1<-vector(nequal,i,jj,left1,left2,left3,left4,rbrsmax)
    //.....nequal is number paths where #br=#sites
    //.....vector(i=2=all found @i=1=not 0 but no more found,
    //.....jj=number of iteratives,1st #not founds, last one is #rows in [3]


//        fassign (ArrayList pseudoedges,Object [][]fpathout,ArrayList edges){
//    @psites<-($1)[1]
//    @bases<-($1)[2]
//    @paths<-($2)
//    @branch<-($3) //c1=branch names, c2=(hap-hap(2),hap-int(1),int-int(0))
//    @branch[@branch[,2]<2,2]<-0 // set all hap-int and int-int branches type to 0
    int nbr = edges.length;
    for (int b = 0; b < nbr; b++) {
        LWEdge edge = edges[b];
        
        if (edge.type != LWEdge.HAPHAP) {
            edge.type = LWEdge.INTINT; // FIXME we are modifying the actual values for this stuff!  Maybe we'll need to change this back?
        }
    }
    
    // add another column of 0s to the array... stored as state and set to 0 when made
    int bmax = paths.length/2 -1;
    int npaths = paths[0].length;
//    System.out.println(bmax + " " + nbr + " " + npaths);

//    @pbranch<-@paths[run(1,@bmax),] 
    // pbranch = 1..bmax
//    @sides<-@paths[run(@bmax+1,@bmax*2),] 
    // sides = paths bmax+1- bmax*2
//    @haps<-@paths[run((@bmax*2)+1,(@bmax*2)+2),]
    // haps = last two (bmax*2+1 and bmax*2+2)
    int [] numsb = new int[npaths];
    
//    int numsb = 0;
    for (int row = 0; row < bmax; row++) {
        for (int col = 0; col < npaths; col++) {
            if (paths[row][col] != null) {
                numsb[col] ++; 
            }
        }
    }
    
    // this is supposed to be sites use pseudosites
    int [] numss = new int[npaths];
    for (int col = 0; col < pseudoedges.length; col++) {
        LWEdge edge = pseudoedges[col];
        numss[col] = edge.differences.size();
    }
    
//    @numsb<-sum(@pbranch>-1) // number of non-1's in each column (a vector with same #cols as paths)
//    @numss<-sum(@psites!=-1) // number of non-1's in each column (a vector with same #cols as paths)
    
    int nequal = 0;
    int nnequal = npaths-1;
    int [] equal = new int[npaths];
    for (int col = 0; col < npaths; col++) {
        if (numsb[col] == numss[col]) {
            equal[nequal++] = col;
        } else {
            equal[nnequal--] = col;
        }
    }
//    @equal<-vconcat(run(1,@npaths)[vector(@numsb==@numss)],run(1,@npaths)[vector(@numsb!=@numss)])
    // 1-numcols where numsb == numss (basically, an array where the row indices are their original indices, but the == are first and the != are 2nd
    
    // 1-numcols where numsb != numss
//    @nequal<-sum(vector(@numsb==@numss)) // the number of cols with numsb == numss
    
    
//    @allpaths<-@pbranch[,@equal] // cols are then reordered to account for this stuff...
//    @allsites<-@psites[,@equal]
//    @allsides<-@sides[,@equal]
//    @allbases<-@bases[,,@equal]
//    @allhaps<-@haps[,@equal]
    
                    
    // rather than redo all of these columns, I am going to keep it in paths, as they are and access it according to the orders in equals...
    // haps, sides, and pbranch are done by here...
/*                    
    @kpaths<-@allpaths[,run(1,@nequal)] // kpaths is all paths where numsb == numss  
    @kpsites<-@allsites[,run(1,@nequal)] // kpsites is all nodes's chars where numsb == numss
    */
    
    int pmax = 30; //?  why 30? max expected number of paths with this branch FIXME this default?  fix it
    
//    @rpaths<-matrix(rep(-1,@pmax*@nbr),@pmax) // rpaths = a matrix 30xnbr set to nulls
    int [] [] allrpaths = new int[nbr][]; 
//    @rbrsite<-array(rep(-1,@bmax*2*@nbr),vector(@bmax,2,@nbr)) // rbrsite is an array 2xbmax*nbr filled by -1s
    Object [] [] [] allrbrsite = new Object[nbr][][];
    int h = 0;
    
    int maxB = 0;
    int maxS = 0;
    int maxP = 0;
    while(h < nbr) {
        h++;
        if (edges[h-1].type < 2) { // all non hap-hap edges
            Object [] hh = fbsearch(edges[h-1], paths, edges, pseudoedges, pmax, equal, nequal, bmax);
//            Object[] {rpaths, rsites, new Integer [] {new Integer(c),new Integer(e), new Integer(f)}};
//          @hh<-fbsearch(@branch[@h,1],@kpaths,@kpsites,@pmax)
    //checks to see if fbsearch found branch in paths where #br=#sites
    //if not is outputs 0 instead of a structure
            if (hh != null) {
//            if(isstruc(@hh)){
                int [] rpaths = (int [])hh[0];
                allrpaths[h-1] = rpaths;
                Object[] [] rbrsite =(Object[][]) hh[1];
                allrbrsite[h-1] = rbrsite;
                /*@rpaths[,@h]<-@hh[1]
                @rbrsite[,,@h]<-@hh[2]
                delete(@hh)*/
                int numEdges = ((Integer)(((Integer[]) hh[2])[1])).intValue();
                int numSites = ((Integer)(((Integer[]) hh[2])[2])).intValue();
                int numPaths = ((Integer)(((Integer[]) hh[2])[0])).intValue();
                if (numPaths > maxP) {
                    maxP = numPaths;
                }
                if (numEdges > maxB) {
                    maxB = numEdges;
                }
                if (numSites > maxS) {
                    maxS = numSites;
                }
                
//                System.out.println("numSites, numEdges = " + numSites + "," + numEdges);
                if (numSites == 1 && numEdges == 0) {
                
//                if((sum(vector(@rbrsite[,2,@h])!=-1)==1)&&(sum(vector(@rbrsite[,1,@h])!=-1)==0)) {
                    // add the first numSites
                    edges[h-1].third.add(rbrsite[0][1]);
//                    System.out.println("adding to edge: "+edges[h-1] +" this: "+ rbrsite[0][1]);
                    
//                    @branch[@h,3]<-@rbrsite[@rbrsite[,2,@h]!=-1,2,@h]
                    edges[h-1].type = 1;
//                    @branch[@h,2]<-1
                }
            }
            
        }
    }
    
//    print2d(allrpaths);
    
    System.out.println("now sites:");
    for (int i = 0; i < nbr; i++) {
        System.out.println("branch i = " +i);
        if (allrbrsite[i] != null)
            print2d(allrbrsite[i]);
        else 
            System.out.println("null");
    }
    System.out.println(maxB);
    System.out.println(maxS);
    System.out.println(maxP);
    
    /*@rpmax<-max(vector(sum(@rpaths!=-1)))
    @rpaths<-@rpaths[run(1,@rpmax),]
    @rbrsmax<-max(vector(
            max(vector(sum(matrix(@rbrsite[,1,])!=-1))),
            max(vector(sum(matrix(@rbrsite[,2,])!=-1)))
    ))
            
    @rbrsite<-@rbrsite[run(1,@rbrsmax),,]
    @left<-sum(@branch[,2]==0)
    @left1<-@left
    if(@left==0){@i<-0;@ii<-1}else{@i<-0;@ii<-0};;*/
/*

    while(@ii<1){@ii<-1
    @upaths<-vector(sum(@rpaths!=-1))
    @m<-0
    while(@m<@nbr){@m<-@m+1
    if(@branch[@m,2]==0&&@upaths[@m]==1){
    @tempu<-unique(vector(@rbrsite[,1,@m]))
    @tempu<-vector(@m,@tempu[@tempu!=-1])
    if(dim(unique(@upaths[@tempu]))==1){
    @tempp<-@rpaths[@rpaths[,@m]!=-1,@m]
    @tempub<-vector(@kpaths[,@tempp])
    @tempus<-vector(@kpsites[,@tempp])
    @n<-0
    while(@n<dim(@tempub)){@n<-@n+1
    if(@tempub[@n]!=-1){@branch[@tempub[@n],3]<-@tempus[@n]
    @branch[@tempub[@n],2]<-3};
    };;};;};;};;
    };;

    @left2<-sum(@branch[,2]==0)
    @left<-@left2

    if(@left!=0){
    @m<-0
    while(@m<@nbr){@m<-@m+1
    if(@branch[@m,2]==0&&@upaths[@m]>=1){
    @tempu<-unique(vector(@rbrsite[,1,@m]))
    @tempu<-vector(@m,@tempu[@tempu!=-1])
    if((sum(@upaths[@tempu])/dim(@tempu))==@upaths[@m]){
    @tempp<-vector(@rpaths[@rpaths[,@m]!=-1,@m])[1]
    @temput<-vector(@kpaths[,@tempp])
    @tempub<-rep(-1,dim(@tempu))
    @tempus<-vector(@rbrsite[,2,@m])
    @p<-0
    @q<-1
    while(@p<dim(@temput)){@p<-@p+1
    if(sum(@tempu==@temput[@p])>0){@tempub[@q]<-@temput[@p]
    @q<-@q+1
    };;};;
    @n<-0
    while(@n<dim(@tempub)){@n<-@n+1
    if(@tempub[@n]!=-1){@branch[@tempub[@n],3]<-@tempus[@n]
    @branch[@tempub[@n],2]<-4};;
    };;};;};;};;
    };;


    @left<-sum(@branch[,2]==0)
    @left3<-@left
    if(@left==0){@i<-1}else{@i<-0};;	
    @jj<-0


    while(@i<1){
    @j<-0
    while(@j<@nbr){@j<-@j+1
    if(@branch[@j,2]==0){
    @k<-0
    while(@k<@rbrsmax){@k<-@k+1
    if(@rbrsite[@k,1,@j]!=-1){
    if(@branch[@rbrsite[@k,1,@j],2]>0){
    @stemp<-@branch[@rbrsite[@k,1,@j],3]
    @l<-0
    while(@l<@rbrsmax){@l<-@l+1
    if(@rbrsite[@l,2,@j]==@stemp){
    @rbrsite[@k,1,@j]<--1
    @rbrsite[@l,2,@j]<--1
    };;};;};;
    };;};;
    if((sum(vector(@rbrsite[,2,@j])!=-1)==1)&&(sum(vector(@rbrsite[,1,@j])!=-1)==0)){
    @branch[@j,3]<-@rbrsite[@rbrsite[,2,@j]!=-1,2,@j]
    @branch[@j,2]<-5
    };;};;
    };;

    @nleft<-sum(@branch[,2]==0)
    @left4<-@nleft

    if(@nleft!=0){
    @m<-0
    while(@m<@nbr){@m<-@m+1
    if(@branch[@m,2]==0&&@upaths[@m]>=1){
    @tempu<-unique(vector(@rbrsite[,1,@m]))
    @tempu<-vector(@m,@tempu[@tempu!=-1])
    if((sum(@upaths[@tempu])/dim(@tempu))==@upaths[@m]){
    @tempp<-vector(@rpaths[@rpaths[,@m]!=-1,@m])[1]
    @temput<-vector(@kpaths[,@tempp])
    @tempub<-rep(-1,dim(@tempu))
    @tempus<-vector(@rbrsite[,2,@m])
    @tempus<-sort(@tempus,down:T)
    @p<-0
    @q<-1
    while(@p<dim(@temput)){@p<-@p+1
    if(sum(@tempu==@temput[@p])>0){@tempub[@q]<-@temput[@p]
    @q<-@q+1
    };;};;
    @n<-0
    while(@n<dim(@tempub)){@n<-@n+1
    if(@tempub[@n]!=-1){@branch[@tempub[@n],3]<-@tempus[@n]
    @branch[@tempub[@n],2]<-6};;
    };;};;};;};;
    };;





    @nleft<-sum(@branch[,2]==0)
    if(@nleft==0){@i<-2}elseif(@nleft==@left){@i<-1}else{@left<-@nleft};;
    @jj<-@jj+1};;

    @left5<-sum(@branch[,2]==0)

    @bransite<-hconcat(vector(@numsb),vector(@numss))[@equal,]

    //pulls out left4 if it is undefined (if all done in first passes)
    if(isdefined(@left4)){
    @res1<-vector(@nequal,@i,@jj,@left1,@left2,@left3,@left4,@left5,@rbrsmax)}else{
    @res1<-vector(@nequal,@i,@jj,@left1,@left2,@left3,@left5,@rbrsmax)};;

    //summarily takes all branches where branch[i,2]==0 and gives it -1 for site and 6 for col2
    @branch[@branch[,2]==0,3]<--1
    @branch[@branch[,2]==0,2]<-7

    @results<-structure(@branch,@rpaths,@rbrsite,@allpaths,@allsites,@allsides,@allbases,@allhaps,@bransite,@res1)
    delete(@psites,@bases,@paths,@branch,@nbr,@bmax,@npaths,@pbranch,@sides,@haps,@numsb,@numss,@kpaths,@kpsites)
    delete(@pmax,@rpaths,@rbrsite,@rpmax,@rbrsmax)
    delete(@left,@i,@j,@k,@stemp,@l,@allsites,@allsides,@allbases,@equal,@nequal,@allhaps,@bransite,@res1)
    delete(@results,return:T)*/
    //    %fassign%
    }
    /*public void fmatch       () {

    //takes output structures from DIFSUM and FASSIGN macros
    //sends to FEND macro
    //for each branch along with branch// & site, it get 1st hap name and bases (1st corresponds to 1st hap)

    //INPUT
    //$1=do 1 means hap-hap & hap int branches uses DIFSUM as $3 and FASSIGN as $4
    //......2=hap-hap only uses DIFSUM as $3, NO $4
    //......3=hap-int only uses only FASSIGN as $3
    //$2=number of total branchs
    //$3=structure from output from DIFSUM macro
    //...[1]=matrix for hap-hap branches c1=branch//,c2=2 for hap-hap,c3=site for branch,c4 1st hap
    //...[2]=matrix of bases for site c1=base for reported hap,c2=other base
    //$4=structure from output from FASSIGN macro
    //...[1]=matrix for all branches c1=branch//,c2=hap-hap(2) (0)=not fount >1=found,c3=site//,c4=1st hap
    //...[2]=cols for each path, rows list of paths that contain this branch -1's filler
    //...[3]=array(c1=other branches shared with this site across shared paths,c2=shared site/sites, for each path)
    //...[4]=allpaths with //br=//sites first, [5]=allsites for paths,[6]=allsides,[7]=allbases,[8]=allhaps
    //...[9]=mat c1=//branches in that path,c2=//sites found between haps in that path
    //...[10]=vector(1st is //paths with //branches=//sites rest are FASSIGN specs, is
    //...[4]-[9] have [10][1] rows //br=//site first then rest are //br!=//site for paths
    //NOTE:  some branches might not be well resolved so the will have -1 or XX in their labelling
    //OUTPUT structure
    //[1]=matrix for branches c1=branch//,c2=how done in FASSIGN macro,c3=site (-1 if not found),c4=1st hap 
    //....(-1 if no site) c5=1 if done reg, 5 if -1 at site, 6 if connected to those with -1 at site
    //[2]=matrix of corresponding bases c1=1st base corresponding to hap, c2=second base, x if not found or uncertain


    @do<-($1)
    @nbr<-($2)
    if(@do<3){
    @difmat<-($3)[1]
    @base2<-($3)[2]
    };;
    if(@do==1){
    @branch<-($4)[1]
    @rpaths<-($4)[2]
    @rbrsite<-($4)[3]
    @allpaths<-($4)[4]
    @allsites<-($4)[5]
    @allsides<-($4)[6]
    @allbases<-($4)[7]
    @allhaps<-($4)[8]
    @bransite<-($4)[9]
    @nequal<-($4)[10][1]
    };;

    if(@do==3){
    @branch<-($3)[1]
    @rpaths<-($3)[2]
    @rbrsite<-($3)[3]
    @allpaths<-($3)[4]
    @allsites<-($3)[5]
    @allsides<-($3)[6]
    @allbases<-($3)[7]
    @allhaps<-($3)[8]
    @bransite<-($3)[9]
    @nequal<-($3)[10][1]
    };;

    if(@do<3){
    @branchhap<-hconcat(run(1,@nbr),matrix(rep(0,@nbr*4),@nbr))
    @fbasehap<-matrix(rep("x",@nbr*2),@nbr)
    @difmat<-hconcat(@difmat,rep(1,dim(@difmat)[1]))
    @a<-0
    while(@a<dim(@difmat)[1]){@a<-@a+1
    @branchhap[@difmat[@a,1],]<-@difmat[@a,]
    @fbasehap[@difmat[@a,1],]<-@base2[@a,]
    };;
    delete(@difmat,@base2)
    if(@do==2){
    @branch<-@branchhap
    @fbase<-@fbasehap
    @diag<-@a
    delete(@branchhap,@fbasehap,@a)
    };;
    };;

    if(@do==1||@do==3){
    @branch<-hconcat(@branch,matrix(rep(-1,@nbr*2),@nbr))
    @branch[@branch[,3]==-1,5]<-5
    @branch[@branch[,3]==-1,4]<--1
    @fbase<-matrix(rep("x",@nbr*2),@nbr)
    @d<-0
    @e<-0
    @f<-0
    @b<-0
    while(@b<@nbr){@b<-@b+1
    if(@branch[@b,5]==-1&&@branch[@b,2]!=2){
    @tpathn<-@rpaths[1,@b]
    @tsites<-@allsites[,@tpathn]
    @tbase<-matrix(@allbases[,,@tpathn])
    @thaps<-@allhaps[1,@tpathn]
    @tbranch<-vector(@b,vector(@rbrsite[@rbrsite[,1,@b]>-1,1,@b]))
    @ntbr<-dim(@tbranch)[1]
    if(sum(vector(@branch[@tbranch,3])==-1)>0){@d<-@d+1
    @branch[@tbranch,5]<-6}else{@e<-@e+1
    @c<-0
    while(@c<@ntbr){@c<-@c+1
    @branch[@tbranch[@c],4]<-@thaps
    @tmut<-@branch[@tbranch[@c],3]
    @fbase[@tbranch[@c],]<-@tbase[@tsites==@tmut,]
    @branch[@tbranch[@c],5]<-1
    @f<-@f+1
    };;};;
    };;
    };;
    @diag<-vector(@b,@c,@d,@e,@f)
    delete(@tpathn,@tsites,@tbase,@thaps,@tbranch,@ntbr,@tmut,@b,@d,@e,@f,@c)
    delete(@rpaths,@rbrsite,@allpaths,@allsites,@allsides,@allbases,@allhaps,@bransite,@nequal)
    };;

    if(@do==1){
    @g<-0
    while(@g<@nbr){@g<-@g+1
    if(@branch[@g,2]==2){
    @branch[@g,]<-@branchhap[@g,]
    @fbase[@g,]<-@fbasehap[@g,]
    };;};;
    @diag<-vector(@a,@diag,@nbr)
    delete(@a,@g,@branchhap,@fbasehap)
    };;
     


    @results<-structure(@branch,@fbase,@diag)
    delete(@branch,@fbase,@diag)
    delete(@results,return:T)
    //    %fmatch%
    }
*/
    /*public void fend         () {
    //uses output from TCSnode and FMATCH macros
    //macro to write output to paste into TCS graph to map characters
    //INPUT
    //$1=TCSnode output, rows for branches see TCSnode macro
    //$2=structure from FMATCH macro
    //...[1]=matrix for branches c1=branch//,c2=how done in FASSIGN macro,c3=site (-1 if not found),c4=1st hap 
    //.......(-1 if no site) c5=1 if done reg, 5 if -1 at site, 6 if connected to those with -1 at site
    //...[2]=matrix of corresponding bases c1=1st base corresponding to hap, c2=second base, "x" if not found or uncertain

    //OUTPUT
    //[1] one with label "branch//!site//ihapnamebases"
    //[2] with label "site//" (this one is easier to  read)
    //vector of all edges with source and nodes filled and branch labels with branch//!site//ihapnamefor1stbase/bases
    //edge [
    //      linestyle "solid"
    //      label "branch//!site//ihapnamebases"
    //      source 25
    //      target 600
    //     ]

    @nbranch<-($1)
    @hap1<-($2)[1]
    @base1<-($2)[2]
    @a1<-paste("edge [")
    @b1<-paste("      linestyle \"solid\"")
    @c1<-paste("      label \"",@hap1[1,1],"i",@hap1[1,3],"i",@hap1[1,4],@base1[1,],"\"",sep:"")
    @d1<-paste("      source",@nbranch[1,7])
    @e1<-paste("      target",@nbranch[1,8])
    @f1<-paste("     ]")
    @g1<-paste("]")
    @done<-vector(@a1,@b1,@c1,@d1,@e1,@f1)
    @nbr<-dim(@nbranch)[1]
    @i<-1
    while(@i<@nbr){@i<-@i+1

    @c1<-paste("      label \"",@hap1[@i,1],"!",@hap1[@i,3],"i",@hap1[@i,4],@base1[@i,],"\"",sep:"")
    @d1<-paste("      source",@nbranch[@i,7])
    @e1<-paste("      target",@nbranch[@i,8])
    @done<-vector(@done,@a1,@b1,@c1,@d1,@e1,@f1)
    }
    @done<-vector(@done,@g1)

    @a1<-paste("edge [")
    @b1<-paste("      linestyle \"solid\"")
    @c1<-paste("      label \"",@hap1[1,3],"\"",sep:"")
    @d1<-paste("      source",@nbranch[1,7])
    @e1<-paste("      target",@nbranch[1,8])
    @f1<-paste("     ]")
    @g1<-paste("]")
    @doned<-vector(@a1,@b1,@c1,@d1,@e1,@f1)
    @nbr<-dim(@nbranch)[1]
    @i<-1
    while(@i<@nbr){@i<-@i+1

    @c1<-paste("      label \"",@hap1[@i,3],"\"",sep:"")
    @d1<-paste("      source",@nbranch[@i,7])
    @e1<-paste("      target",@nbranch[@i,8])
    @doned<-vector(@doned,@a1,@b1,@c1,@d1,@e1,@f1)
    }
    @doned<-vector(@doned,@g1)
    @donedd<-structure(@done,@doned)
    delete(@nbranch,@hap1,@base1,@a1,@b1,@c1,@d1,@e1,@f1,@g1,@i,@nbr,@done,@doned)
    delete(@donedd,return:T)
    //    %fend%
    }*/
    
    /*public void hapdif       (){

    //used in DIFSUM macro
    //macro to find and report differences between haplotypes
    //will spit of site number, and bases for each hap at that site
    //INPUT
    //$1=vector of hap labels corresponding to rows of $2 seq matrix
    //$2=matrix of seqs corresponding to $1 hap labels
    //$3=vector of sites nums corresponding to columns of $2 seq matrix
    //$4=vector with pair of haps to compare
    //OUTPUT
    //structure of
    //[1]=vector of site or sites differing between the haps
    //[2]=matrix with rows for each site that differs, c1=base for haps[1],c2=base for hap2
    @hapname<-($1)
    @seqs<-($2)
    @sites<-($3)
    @haps<-($4)
    @isites<-run(1,dim(@sites)[1])
    @hapname<-hconcat(run(1,dim(@hapname)[1]),@hapname)
    @haprow<-vector(0,0)
    @i<-0
    @k<-0
    while(@i<2){@i<-@i+1
    @j<-0
    while(@j<dim(@hapname)[1]){@j<-@j+1
    if(@haps[@i]==@hapname[@j,2]){@haprow[@i]<-@hapname[@j,1]
    @k<-@k+1
    @j<-dim(@hapname)[1]
    };;
    };;};;
    @pair<-@seqs[@haprow,]'
    @diffs<-@isites[@pair[,1]!=@pair[,2]]
    @bases<-@pair[@diffs,]
    @rdiffs<-@sites[@diffs]
    @results<-structure(@rdiffs,@bases)
    delete(@hapname,@seqs,@sites,@haps,@isites,@haprow,@i,@j,@pair,@diffs,@rdiffs,@bases)
    delete(@results,return:T)
    //    %hapdif%
    }*/
    public static void print2d(Object[][] mat) {
        int rows = mat.length;
        int cols = mat[0].length;
        for (int i = 0; i < rows; i++) {
            System.out.print(i+1);
            for (int j = 0; j < cols; j++) {
                if (mat[i] != null && mat[i][j] != null)
                    System.out.print("\t"+mat[i][j].toString());
                else
                    System.out.print("\t" + -1);
            }
            System.out.println();
        }
    }
    
    public static void print2d(int[][] mat) {
        int rows = mat.length;
        int cols = mat[0].length;
        for (int i = 0; i < rows; i++) {
            System.out.print(i+1);
            for (int j = 0; j < cols; j++) {
                if (mat[i] != null && mat[i][j] != 0)
                    System.out.print("\t"+mat[i][j]);
                else
                    System.out.print("\t" + -1);
            }
            System.out.println();
        }
    }
    public static Object [][] fnode(LWEdge edge, TaxaItem searchNode, ArrayList edges, int lim){
    //        System.out.println("fnode(" + edge.toString() + "," + searchNode.toString() + ",edges,lim");
    //used within FSTEP and FPATH macros, uses output from TCSnode macro
    //small macro to take internal node from one branch and search
    //it is to be used within macro to search for path
    //for other branches with the same node besides that branch
    //it reports the branches and for each branch whether the instance of that
    //node is in the source(1) or target position
    //it's report vector starts as rep(0,as many as most # you would expect for all routes)
    //INPUT
    //$1=vector(branch#,internal node name to search for)
    //$2=takes matrix from TCSnode output (i.e. branch) for
       //all branches without hap-hap branches (i.e. branch[branch[,6]<2,])
       //matrix(c1=branch//,c2=source hapname,c3=targethapname,
              //c4=source hap(1)/internal(0),c5=target hap(1)/internal(0)
              //c6=(0=2Internal,1=1internal&1hap,2=2haps),c7=source nodename,c8=target nodename)
    //OPTIONAL $3=scalar determining the length for vector of branches this number needs to be same
              //max number of connections minus original to this internal node
              //DEFAULT=7 which is probably more than #connections for any internal node
    //OUTPUT
    //matrix sorted by c3 so irrelevant(c3=-1),then unfinished branches(c3=0),finished(c3=1)
           //c1=vector of $2 length with filled with branches with matching node rest are 0's
           //c2=corresponding vector with node indentified as source(7) or target(8) on branch
           //c3=internal-hap(1) or internal/internal(0)
           //c4=hapname or irrelevant nodename at other end, only name for final call
           //c5=node on other side for next search
           //c6=1 if real branch,-1 if not, later used to modify whether done or not
        //    @list<-($1)
        //    @branch<-($2)
    /*if(($N)<=2){@lim<-7}else{@lim<-($3)}*/
    int num = edges.size(); // again, this is all edges, not just the ones without haphap
    //    @num<-dim(@branch)[1]
    //    @set<-matrix(rep(-1,@lim*6),@lim) // create a 6 by lim matrix
    Object [][] set = new Object [lim][6];
    int k = 1;
        int j = 0;
        while(j < num) { 
            j++;
            LWEdge edge2 = (LWEdge) edges.get(j-1);
            // i == 7 => source nodename
            // i == 8 => target nodename
            if (edge2.source == searchNode || edge2.dest == searchNode) { // i == 7 || i == 8  // do we need to do it twice if both are true? No! 
                if (edge2 != edge) {
                    set[k-1][0] = edge2;
                    set[k-1][1] = new Integer((edge2.source == searchNode)?7:8);
                    set[k-1][2] = new Integer(edge2.type); // FIXME this is supposed to be finished/unfinishe/irrelevant!
                    if (((Integer)set[k-1][1]).intValue() == 7) {
                        set[k-1][3] = edge2.dest; //FIXME edge2.dest should be target hapname... I am using the same for target node name?
                    } else {
                        set[k-1][3] = edge2.source; // FIXME edge2.source should be source hapname...
                    }
                    if(((Integer)set[k-1][1]).intValue() == 7) {
                        set[k-1][4] = edge2.dest; // target nodename
                    }else {
                        set[k-1][4] = edge2.source; // source nodename
                    }
                    set[k-1][5] = new Integer(1); // FIXME do I need to go one less?
                    k++;
                }
            }
        }
        //        sort them now...
      	//              matrix sorted by c3 so irrelevant(c3=-1),then unfinished branches(c3=0),finished(c3=1) // I didn't sort it!
        
        //    @results<-@set[grade(@set[,3]),] // sort by edge types? //c6=(0=2Internal,1=1internal&1hap,2=2haps)
        // marvel at my ultra-efficient N^3 sort (applicable only since there are 3 types...)
        Object [][] sortedset = new Object [lim][6];
        
        int cur = 0;
        for (int i = 0; i < lim; i++) {
            if (set[i][2] == null) {
                //if (((Integer)set[i][2]).intValue() == -1) {
                //System.out.println("there should not be any -1's?  Shouldn't this be a null or something?");
                sortedset[cur++] = set[i];
            }
        }
        //        System.out.println("cur = " +cur);
        for (int i = 0; i < lim; i++) {
            if (set[i][2] != null && ((Integer)set[i][2]).intValue() == 0) {
                sortedset[cur++] = set[i];
            }
        }
        for (int i = 0; i < lim; i++) {
            if (set[i][2] != null && ((Integer)set[i][2]).intValue() == 1) {
                sortedset[cur++] = set[i];
            }
        }
        return sortedset;
				//    delete(@list,@branch,@lim,@num,@set,@k,@i,@j)
				//    delete(@results,return:T)
				//    %fnode%
    }
    public static Object[] fbsearch     (LWEdge find,Object[][] paths, LWEdge[] edges,  LWEdge[] pseudoedges, int pmax, int [] equal,int nequal, int bmax) {

    //used within FASSIGN macro
    //macro to take branch and find all paths that contain that branch
    //it also spits sites that are shared between all paths
    //NOTE:  when that branch is not found within $2 then it calls results 0
    //in FASSIGN it checks whether it gets structure or not

    //INPUT
    //$1 the branch name to search with
    //$2 matrix of branches for paths,col=paths only paths with #branches=#sites
    //$3 matrix of sites for paths, col=paths  only
    //$4 max expected number of paths with this branch

    //OUTPUT structure
    //[1]=vector //rows=$4 that contain that branch -1's for filler
    //[2]=matix(c1=all OTHER branches shared across all paths, c2=all sites shared across all paths
    //....-1's for filler, #rows=#rows of $2 or $3=max #branches in any path
    //NOTE:  when that branch is not found within $2 then it calls results 0
    //in FASSIGN it checks whether it gets structure or not

    //    @find<-($1)
    //@pbranch<-($2) // in paths 1..bmax, referenced by equal, and not past nequal...(equals is a column!)
    //@psites<-($3) // in pseudoedges
    //    @nps<-dim(@pbranch)
    int nps1 = bmax; //FIXME we need to test this on one that has some branches != #mutations, since that may throw us a curve
    int nps2 = nequal;
    int []rpaths = new int[pmax]; // all start at 0 instead of -1  FIXME  change this from an array to a collection, to prevent overloading the arraylength... 
//    @rpaths<-rep(-1,($4))
    
//    @rsites<-matrix(rep(-1,@nps[1]*2),@nps[1])
    
    int c = 1;
    int a = 0;
    /*ArrayList temps = new ArrayList();
    ArrayList tempb = new ArrayList();*/
    HashSet noDupsB = new HashSet();
    HashSet noDupsS = new HashSet();
    while(a < nps2) {
        a++;
        int b = 0;
        
        while(b < nps1){
            b++;
            if((LWEdge)paths[b-1][equal[a-1]] == find){
                rpaths[c-1] = equal[a-1]+1; //FIXME note, I am storing the equalized pathref +1, so any use of rpaths doesn't require using equal..., but needs to -1
                // found a match, so add the appropriate row's entries...to noDupsB, except nulls, and anything past bmax, and find itself...
                
                // get all non-null entries in all rows (from 1 to bmax) and in this column (unless it = find)
                for (int row = 0; row < bmax; row++) {
                    
                    if (paths[row][equal[a-1]] != null && paths[row][equal[a-1]] != find) {
                        noDupsB.add(paths[row][equal[a-1]]);
                    }
                }
                // also, add all the sites from pseudoedges[equal[a-1]] to noDupsS 
                noDupsS.addAll(pseudoedges[equal[a-1]].differences);
                
//                @ub<-@ub[@ub!=-1&&@ub!=@find] // remove the -1's, and find
                
//                @us<-@us[@us!=-1] // remove all the -1s
                c++;
            }
        }
    }
    /*System.out.println("noDupsB");
    print1d(noDupsB.toArray());
    System.out.println("noDupsS");

    print1d(noDupsS.toArray());*/
    
    
    // take note that a is indexed starting at 1, so we can deal with the fact that they were initialized to 0, rather than -1!
    
    // instead of creating these new temps, use rpaths as a reference in... if it != zero, the column will be included.. and there are c non-zero columns...
    //    @tempb<-@pbranch[,vector(@rpaths[@rpaths!=-1])]
    
    //    @temps<-@psites[,vector(@rpaths[@rpaths!=-1])]
    
    
    int nt1 = nps1;
    int nt2 = c-1;
    
    //checks to see if that branch is found in any of the paths where #br=#sites
    //if nothing is in @temp, then dim(@tempb)==0
    //if nt==0 then reports results as results<-0
    //in fassign use isstruc() to identify whether results is structure or not
    //if it is structure then is was found
    if(nt2 == 0){ // I think this is the same as dim(@tempb) = 0 
        return null;
    } else {
    /*    @ub<-unique(vector(@tempb)) // remove all dups
        @us<-unique(vector(@temps)) // remove all dups
        @ub<-@ub[@ub!=-1&&@ub!=@find] // remove the -1's, and find
        @us<-@us[@us!=-1] // remove all the -1s
        */  
        //FIXME this part can likely be done more efficiently!  I was just doing it how taylor did.. to get it working
        Object [][]rsites = new Object[nps1][2];
        int e = 1;
//        int d = 0;
        
        Iterator i = noDupsB.iterator();
        
//         for each branch in noDupsB
        while(i.hasNext()) {
//            d++;
            LWEdge edge = (LWEdge)i.next();
            
            int col = 0;
            int countb = 0;
            while(rpaths[col] != 0) {
                for (int row = 0; row < bmax; row++) {
                        
                    if (paths[row][rpaths[col]-1] == edge) {
                        countb ++;
                        break;
                     }
                }
                col++;
            }
//            int countb = sum(vector(sum(@tempb==@ub[@d]))); // find out how many of the columns this branch was in...
            if(countb == nt2){ // if this branch was in all columns, store it...
                rsites[e-1][0] = edge;
//                System.out.println(e);
                e++;
            }
        }
        i = noDupsS.iterator();
        
        /*ArrayList as = new ArrayList();
        as.add(new Integer(1));
        Integer id =new Integer(1); 
        System.out.println(as.contains(id));*/
    int f = 1;
//    int g = 0;
//    while(g < noDupsS.size()){
    while(i.hasNext()) {
//        g++;
        Integer in = (Integer)i.next();
        int col = 0;
        int counts = 0;
        while(rpaths[col] != 0) {
            //            HashSet sites = new HashSet(pseudoedges[equal[a-1]].differences);        
                if (pseudoedges[rpaths[col]-1].differences.contains(in)) {
                    counts ++;
                    //                    break;
                 }
                //                noDupsS.addAll(pseudoedges[equal[a-1]].differences);
            col++;
        }
        //        int counts = sum(vector(sum(@temps==@us[@g]))); // find out how many of the columns this nuc site was in...
        if(counts == nt2){ // if this site was in all columns, store it...
            rsites[f-1][1] = in;
//            System.out.println(f);
            f++;
            
        }
    }
    // rpaths is an index vector basically
    // rsites is an info vector
    // c, e, f are important indices, giving num columns (number columns left, number of branches existing in all paths, and num sites in all paths) 
//    @results<-structure(@rpaths,@rsites,vector(@c,@e,@f),@temps)
    /*System.out.println("rpaths:");
    print1d(rpaths);
    System.out.println("rsites:");
    print2d(rsites);
    System.out.println("c,e,f = " + c + "," + e + "," +f);*/
    	return new Object[] {rpaths, rsites, new Integer [] {new Integer(c-1),new Integer(e-1), new Integer(f-1)}};
    
    }
    
//    %fbsearch%*/
    }
    /*public void fsite        () {

    //uses output from FMATCH macro and used within fTCS macro
    //macro to find //branches for each site and what branches they are
    //INPUT
    //[1]=matrix from fmatch output[1] (branches with site designations
    //[2]=vector of site//s from seqfile[3]
    //OUTPUT
    //[1]= matrix rows c1=sitenumbers(-1 last branches not defined),c2=//branches for site,c3-end actual
    //.....branches for each site 0's=nothing
    @given<-($1)
    @sites<-($2)
    @sites<-vector(@sites,-1)
    @sn<-dim(@sites)[1]
    @sitebr<-matrix(rep(0,@sn*100),@sn)
    @snn<-dim(@sitebr)[2]
    @a<-0
    while(@a<@sn){ 
        @a<-@a+1;
        @temp<-@given[@given[,3]==@sites[@a],1];
        @tn<-dim(@temp)[1];
        if(!isnull(@temp)) {
            if(@tn>@snn) {
                @sitebr<-hconcat(@sitebr,matrix(rep(0,@sn*(@tn-@snn)),@sn));
                @snn<-dim(@sitebr)[2];
             }
            @sitebr[@a,run(1,@tn)]<-@temp'
        }
    }
    @numbr<-vector(sum(@sitebr'!=0))
    @sitebr<-@sitebr[,run(1,max(@numbr))]
    @results<-hconcat(@sites,@numbr,@sitebr)
    delete(@given,@sites,@sn,@sitebr,@snn,@a,@temp,@tn,@numbr)
    delete(@results,return:T)
    //    %fsite%

    }*/
    /*public void fTCSdescribe() { 
    //description of macros within fTCS macro
    //macro to combine all macros
    //macro list:

    //INPUT
    //$1=log file hap=node relations
    //$2=branchs from graph file
    //$3=structure with hapnames,seqs,sites
    //$4=number of steps in TCS analysis


    //fTCS           uses: all other macros combines them all
    //rdTCS		uses: log and graph files
    //...............sends to main info for rest of macros
    //readTCS is now not used
    //readTCS:       uses: log and graph file names or bywords:T vectors of each
    //...............sends to TCSnode
    //TCSnode:       uses: original input from log and graph files ($1,$2)
    //...............sends to: DIFSUM, FPATH, FASSIGN, FMATCH
    //DIFSUM/HAPDIF:  uses: TCSnode output and seqs,hapnames,sites ($3)
    //...............sends to: FMATCH
    //FPATH/FNODE:   uses: TCSnode output for branches !=hap-hap, step length from TCS ($4)
    //...............sends to: DIFIN and FASSIGN
    //DIFIN/HAPDIF...uses: FPATH output and seqs,hapnames,sites ($3)
    //...............sends to: FASSIGN
    //FASSIGN/FBSEARCH:  uses: DIFIN and FPATH outputs, TCSnode output[,vector(1,6)]
    //...............sends to: FMATCH
    //FMATCH:        uses: DIFSUM and FASSIGN
    //...............sends to: FEND
    //FSITE:         uses: FMATCH and sites from seqfile ($3)[3]
    //...............sends to:  ends with mat for each site, //branches and what they are
    //FEND:          uses: TCSnode and FMATCH
    //...............sends to: ends with output of edges to paste back into TCS graph with branches labelled
    //.........................with branch//,site//,1st hap,basesstarting with 1st hap
    //
    //
    //fTCS:   overall macro to combine them all and deal with combinations of hap-hap,hap-int,int-int files
    //........it spits out output graph file, saves structure of output for other macros
    //rdTCS:  parses log and graph files for hapnames,seqs,nodeID,edges,nsteps,count for haps
    //readTCS is not used anymore
    //1=readTCS:  parses log & graph files makes input for TCSnode
    //2=TCSnode:  matches hapnames and node name for branches from TCS log and graph files
    //............outputs matrix rows=branches with, branch//,nodenames,hapnames,hap-hap,hap-int,int-int
    //3=DIFSUM/HAPDIF:  Takes TCSnode output and determines matrix with sites hap and bases for all hap-hap branches
    //................  HAPDIF takes finds the sites that differ between 2 haps and the bases that correspond
    //4=FPATH/FNODE:  takes only hap-int,int-int branches from TCSnode and step lengh ($4) to find all unique paths
    //................between haps, the sides, and the hap names
    //................FNODE takes a node on one side of a branch and finds all other branches with that node then
    //................reports the other side of branch and whether its hap or internal, used to lead paths
    //5=DIFIN/HAPDIF: takes output from FPATH and hapname,seqs,sites ($3) to find sites and bases for paths
    //................HAPDIF same as in DIFSUM/HAPDIF
    //6=FASSIGN/FBSEARCH:  takes path branches and sites from DIFIN and paths from FMATCH, and the branch names and
    //.....................hap-hap/hap-int/int-int designation from TCSnode output, for !=hap-hap branches it finds
    //.....................all paths(//branch=//sites) that contain it, finds the branches and sites shared across all
    //.....................of paths sharing that branch. If no other branches and 1 site then that branch is defined.
    //.....................If 1 paths and multiple branches, then each branch is assigned one of the sites, similar for
    //.....................multiple paths that share subset of branches and sites.  NOTE some not resolved and some paths
    //.....................have //br>//sites (expected) but also found impossibility of //sites>//branches (once in >360 paths)
    //.....................outputs branch mat with most !=hap-hap branches resolve, path list for branches,shared branches
    //.....................and sites for each branch,reordered paths,path sites,path sides,path bases,path haps (reordered
    //.....................with //br=//sites then //br!=//sites, mat of //branches&//sites for each branch, and //branches where
    //.....................//br=//sites to along with other diagnostics for the macro
    //.....................FBSEARCH takes branch, finds all paths then finds shared sites and branches
    //7=FMATCH:  takes all output for hap-hap from DIFSUM macro, and all output from FASSIGN macro, for each branch it 
    //...........attempts to take site and associate it with a hapname and the bases to it.
    //8=FSITE:  Takes fmatchoutput[1] and seqfile(3) and determines for each site the //branches it is on and what they are
    //9=FEND:  takes TCSnode output and FMATCH output to makes output for each branch (edge) that can be pasted in the TCS
    //.........graph file in place of the previous edges this time with labels read be TCS for each branch that tells 
    //.........branch//!site//ihapname bases
//    %fTCSdescribe%


    }*/
    
    }
