package EDU.auburn.VGJ.gui;


//dp 2-5-04
import edu.stanford.ejalbert.BrowserLauncher;

import EDU.auburn.VGJ.algorithm.GraphAlgorithm;
import EDU.auburn.VGJ.calc.*;
//jake 2-7-01
import EDU.auburn.VGJ.graph.GMLlexer;
import EDU.auburn.VGJ.graph.GMLobject;
import EDU.auburn.VGJ.graph.Graph;
import EDU.auburn.VGJ.graph.Node;
import EDU.auburn.VGJ.graph.ParseError;
import EDU.auburn.VGJ.gui.ScrolledPanel;
import EDU.auburn.VGJ.gui.ViewportScroller;
// import EDU.auburn.VGJ.nesting.*;
//jake 2-7-01
import EDU.auburn.VGJ.util.DDimension;
import EDU.auburn.VGJ.util.DPoint;

/*
    File: GraphWindow.java
    5/29/96   Larry Barowski
  */
//version pass jake pict 02/07/01
import clad.*;

import java.awt.BorderLayout;
import java.awt.TextField;
import java.awt.Button;
import java.awt.CheckboxMenuItem;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Event;
import java.awt.FileDialog;
import java.awt.Font;
import java.awt.Label;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.io.StringBufferInputStream;

import java.net.URL;

import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.JTextField;
import javax.swing.JPanel;
import javax.swing.Timer;


//import javax.swing.event.*;
//import javax.swing.text.*;


/**
 *    GraphWindow is a graph editing tool window.
 *    </p>Here is the <a href="../gui/GraphWindow.java">source</a>.
 *
 * @author     Larry Barowski
 * @created    June 3, 2003
 */
public class GraphWindow
		 extends JFrame
{
	// public final static int ONE_SECOND      = 1000;
	protected static int spacing_           = 4;
	private static URL context_             = null;
	// spacing between controls

	/**
	 *    spacing of controls
	 */
	private boolean gapmode                 = true;
	public dna dnac;
	public LPanel p;
	public JProgressBar progressBar;
	public Button run_button                = new Button("RUN");
	public JTextField statustextField;
	// public Button stop_button               = new Button("STOP");
	//	public static JTextField   textField;
	public JTextField manualConnections     = new JTextField(5);
	public Checkbox manualBox;
	public Label calcLimitLabel;
	public Choice conLimit;
	// public Menu weightsMenu                 = new Menu("Outgroup Weights");
	public boolean cancel                   = false;
	public String filename;
	public String outfile;
	public String logfile;
	public Label infilelabel;
	private GMLobject GMLfile_              = null;
	private Hashtable algHashTable_;
	private Hashtable algNameHashTable_;
	private AlgPropDialog algPropDialog_    = null;
	private Menu algorithmMenu_;
	private CalcDialog calcDialog_          = null;
	//jake 2-7-01
	private CheckboxMenuItem cbmiDirected_;
	private Panel controls_;
	private boolean doDistances             = false;
	private FileDialog fd                   = null;
	private FileDialog fd1                  = null;
	private FileDialog fd2                  = null;
	private FileDialog fd3                  = null;
	private String filename_                = null;
	private FontPropDialog fontPropDialog_  = null;
	private GraphCanvas graphCanvas_;
	private Graph graph_;
	private GroupControl groupControl_      = null;
	private Hashtable menuHashTable_;
	//private NestDialog nestDialog_          = null;
	private pictdialog pictDialog_          = null;
	private ViewportScroller portScroller_;
	private PSdialog psDialog_              = null;
	private Label scaleLabel_;
	private double scale_                   = 1.0;
	private CheckboxMenuItem showControls_;
	private ScrolledPanel viewingPanel_;
	// private Timer timer                     = new Timer(ONE_SECOND, new TimerListener());


	public GraphWindow(Graph graph_in)
	{
		construct(graph_in);
	}


	public GraphWindow(boolean directed)
	{
		construct(new Graph(directed));
	}


	public static void setContext(URL context)
	{
		context_ = context;
	}


	public void SetMaxDistance(int distance)
	{
		dnac.SetMaxDistance(distance);
	}


	private String SaveStandardHelper(String filename, GMLobject GMLo)
	{

		// fillTaxaInfo(GMLobject GMLo)

		// From the Graph
		// get all of the nodes (print the number)
		// print the coordinates of all of the nodes
		// print all the edges
		// save this to a file...
		// String outputString  = "";
		GMLobject nodegml;
		GMLobject gml;
		GMLobject GMLtmp;
		gml = GMLo;

		// If the GML doesn't contain a graph, assume it is a graph.
		GMLtmp = gml.getGMLSubObject("graph", GMLobject.GMLlist, false);

		if (GMLtmp != null)
		{
			gml = GMLtmp;
		}

		int nodeCount          = graph_.numberOfNodes();
		String outputString    = "";
		int existingNodeCount  = nodeCount;

		// also output the
		double[] xs            = new double[nodeCount];
		double[] ys            = new double[nodeCount];
		double xoffset         = 0.0;
		double yoffset         = 0.0;

		// go through and get all nodes...
		// int nodeCount        = 0;

		for (nodegml = gml.getGMLSubObject("node", GMLobject.GMLlist, false); nodegml != null; nodegml = gml.getNextGMLSubObject())
		{
			// put them into an array, and then read them out one at a time
			//also, keep track of the most negative x,y so that we can add that offset

			// nodeCount++;
			int id              = -1;

			Integer tmpint;
			tmpint = (Integer) nodegml.getValue("id", GMLobject.GMLinteger);
			id = tmpint.intValue();

			// graphics, center, {x, y}
			Double x;
			Double y;
			GMLobject graphics;
			GMLobject center;

			String label;

			label = (String) nodegml.getValue("label", GMLobject.GMLstring);
			if (label.equals(" "))
			{
				existingNodeCount--;
			}

			graphics = nodegml.getGMLSubObject("graphics", GMLobject.GMLlist, false);
			// System.out.println("graphics = " + graphics);
			center = graphics.getGMLSubObject("center", GMLobject.GMLlist, false);
			// System.out.println("center = " + center);
			x = (Double) center.getValue("x", GMLobject.GMLreal);
			y = (Double) center.getValue("y", GMLobject.GMLreal);

			// System.out.println("x = " + x);
			// System.out.println("y = " + y);

			// outputString += x + " " + y + "\n";
			// save them in the arrays in the proper order

			//get the list perhaps?

			double tempx        = x.doubleValue();
			double tempy        = y.doubleValue();
			xs[id] = tempx;
			ys[id] = tempy;

			if (tempx < xoffset)
			{
				xoffset = tempx;
			}

			if (tempy < yoffset)
			{
				yoffset = tempy;
			}

			// keep track of the most negative x and y

			//I need to put these in order numerically I think... but maybe it doesn't matter?

		}

		for (int r = 0; r < nodeCount; r++)
		{

			outputString += (xs[r] - xoffset) + " " + (ys[r] - yoffset) + " " + dnac.getHaplotypes(r) + "\n";
		}

		GMLobject edgegml;

		// now get all edges
		// is there an easy way to know how many real exist?  " "
		for (edgegml = gml.getGMLSubObject("edge", GMLobject.GMLlist, false); edgegml != null; edgegml = gml.getNextGMLSubObject())
		{

			Integer source;
			Integer target;
			source = (Integer) edgegml.getValue("source", GMLobject.GMLinteger);
			target = (Integer) edgegml.getValue("target", GMLobject.GMLinteger);

			int s;

			int t;
			s = source.intValue() + 1;
			t = target.intValue() + 1;
			if (source != null && target != null)
			{
				outputString += s + " " + t + "\n";
			}
		}

		// System.out.println("Network = \n" + outputString);
		outputString = nodeCount + " " + existingNodeCount + "\n" + outputString;
		return outputString;
	}


	public void SaveStandard(String filename)
	{
		GMLobject GMLo  = loadFile(filename);
		graphCanvas_.selectRoot();
		applyAlgorithm("Tree Up");
		graphCanvas_.removeGroups();

		try
		{
			PrintStream ps      = new PrintStream(new FileOutputStream(filename_));
			PrintStream netF    = new PrintStream(new FileOutputStream(filename_ + ".net"));
			if (GMLfile_ == null)
			{
				GMLfile_ = new GMLobject(null, GMLobject.GMLfile);
				GMLfile_.addObjectToEnd(new GMLobject("graph", GMLobject.GMLlist));
			}

			GMLobject gmlgraph  = GMLfile_.getGMLSubObject("graph", GMLobject.GMLlist, false);
			graph_.setGMLvalues(gmlgraph);
			gmlgraph.prune();
			ps.println(GMLfile_.toString(0));

			// print out the standard format network for comparing
			String net          = SaveStandardHelper(filename, GMLo);
			netF.println(net);
			netF.close();

			ps.close();
		}
		catch (Exception e)
		{
			System.out.println("Error writing Standard Network File!\n" + e);
		}

		// filename = filename + ".con";
		// pictDialog_.Save(filename);

		// print out all the right stuff now...


	}


	public void PictSave(String filename)
	{

		GMLobject GMLo  = loadFile(filename);
		// dnac = new dna(this);
		// dnac.fillTaxaInfo(GMLo);



		// loadFile(file);
		// graphCanvas_.selectAll();
		graphCanvas_.selectRoot();
		applyAlgorithm("Tree Down");

		// Now save the graph as a pict, and move on...
		if (pictDialog_ == null)
		{
			pictDialog_ = new pictdialog(this, graphCanvas_);
		}
		// else
		// {
		// pictDialog_.pack();
		// pictDialog_.setVisible(true);

		// }
		// pictDialog_.pack();
		// pictDialog_.pack();
		filename = filename + ".PICT";
		pictDialog_.Save(filename);

	}


	public void RUN()
	{
		//	System.out.println(" in RUN, filename = " + filename);
		dnac.dodna(filename, outfile, 0, doDistances, logfile);

	}


	public boolean open(String fileToRun)
	{
		dnac = new dna();
		outfile = fileToRun.concat(".graph");
		logfile = fileToRun.concat(".log");

		return true;
	}


	public boolean action(Event event, Object what)
	{

		if (event.target instanceof Choice)
		{

			Choice choice  = (Choice) (event.target);
			String label   = choice.getSelectedItem();

			if (label.equals("Gaps = 5th state"))
			{
				gapmode = true;
			}
			else if (label.equals("Gaps = missing"))
			{
				gapmode = false;
			}

			int mode       = GraphCanvas.SELECT_BOTH;

			if (label.equals("Create Branches"))
			{
				mode = GraphCanvas.CREATE_EDGES;
			}
			else if (label.equals("Create Nodes"))
			{
				mode = GraphCanvas.CREATE_NODES;
			}
			else if (label.equals("Select Branches"))
			{
				mode = GraphCanvas.SELECT_EDGES;
			}
			else if (label.equals("Select Nodes"))
			{
				mode = GraphCanvas.SELECT_NODES;
			}
			else if (label.equals("Select Nodes & Branches"))
			{
				mode = GraphCanvas.SELECT_BOTH;
			}

			graphCanvas_.setMouseMode(mode);
		}

		if (event.target instanceof Checkbox)
		{
			CheckboxGroup cbgrp  = ((Checkbox) (event.target)).getCheckboxGroup();
			Checkbox selected    = cbgrp.getSelectedCheckbox();
			String label         = selected.getLabel();

			int mode             = GraphCanvas.SELECT_BOTH;
			if (label.equals("Fix Connection Limit At "))
			{
				// disable the calculate choicebox
				conLimit.setEnabled(false);
				manualConnections.setEnabled(true);
			}
			else
			{
				conLimit.setEnabled(true);
				manualConnections.setEnabled(false);
				// disable the fixed connection stuff
			}
		}
		else if (event.target instanceof CheckboxMenuItem)
		{

			String label   = ((CheckboxMenuItem) (event.target)).getLabel();
			boolean state  = ((CheckboxMenuItem) (event.target)).getState();

			if (label.equals("Scale Node Size"))
			{
				graphCanvas_.scaleBounds(state);
			}
			else if (label.equals("Show Controls  [s]"))
			{

				if (state)
				{
					controls_.setVisible(true);

				}
				else
				{
					controls_.setVisible(false);
				}

				validate();
			}
			else if (label.equals("Directed"))
			{
				graphCanvas_.setDirected(state);
			}
			else if (label.equals("Use Node ID As Default Label"))
			{
				Node.setDefaultLabel(state);
				graphCanvas_.update(false);
			}
			else if (label.equals("High Quality Display"))
			{
				graphCanvas_.setQuality(state == false ? 1 : 2);
			}
		}
		else if (event.target instanceof MenuItem)
		{

			GraphAlgorithm alg;
			MenuItem menuitem   = (MenuItem) event.target;
			alg = (GraphAlgorithm) algHashTable_.get(menuitem);

			if (alg != null)
			{
				applyAlgorithm_(alg);
			}
			else
			{

				String label  = menuitem.getLabel();

				if (label.equals("Help"))
				{
					try {
						BrowserLauncher.openURL("file://" + System.getProperty("user.dir") + "/docs/TCS1.16.html");
						}
					catch (IOException exc)
		        		{
		        		exc.printStackTrace();
		        		}
	
					/* new OpenURL("file://" + System.getProperty("user.dir") + "/docs/TCS1.16.html");*/
					
					//System.err.print("trying to open " + "file://" + System.getProperty("user.dir") + "/Distribution/TCS 1.16/docs/TCS1.16.html");
					/*
					JFrame frame  = new JFrame();
					JOptionPane.showMessageDialog(frame, "Read the documentation...", "TCS advice", JOptionPane.INFORMATION_MESSAGE);
					frame.dispose();
					*/
				}
				else if (label.equals("Citation"))
				{

					JFrame frame  = new JFrame();
					JOptionPane.showMessageDialog(frame, "Clement M, Posada D, Crandall KA. 2000" + 
					"\nTCS: a computer program to estimate gene genealogies" + 
					"\nMolecular Ecology 9 (10): 1657-1660", 
					"TCS citation", JOptionPane.INFORMATION_MESSAGE);
					frame.dispose();
				}
				else if (label.equals("TCS web site"))
				{
					try {
						BrowserLauncher.openURL("http://darwin.uvigo.es/tcs.html");
						}
					catch (IOException exc)
		        		{
		        		exc.printStackTrace();
		        		}
				}

 				else if (label.equals("Credits"))
				{
				JFrame frame  = new JFrame();
					JOptionPane.showMessageDialog(frame, "TCS is being developed by:" + 
					"\n   Mark Clement\n   Jacob Derington\n   Steven Woolley\n   David Posada" +
					"\n\n   @BYU Computer Science (MC, JD, SW) & University of Vigo, Spain (DP)" + 
					"\n\nTCS uses the freeware VGLJ for graph display and manipulation and GUI architecture" + 
					"\n   http://www.eng.auburn.edu/department/cse/research/graph_drawing/graph_drawing.html" + 
					"\n   VGJ may be distributed under the terms of the GNU General Public License, Version 2" + 
					"\n\nThanks to all the users for reporting problems !", "TCS credits", JOptionPane.INFORMATION_MESSAGE);
					frame.dispose();
				}
				else if (label.equals("Open Graph (GML)"))
				{

					String filename  = null;

					if (fd1 == null)
					{

						try
						{
							fd1 = new FileDialog(this, "Open VGJ File (GML) graph", FileDialog.LOAD);
							fd1.setVisible(true);

						}
						catch (Throwable e)
						{

							MessageDialog dg  = new MessageDialog(this, "Error", "It appears your VM does not allow file loading.", true);

							return true;
						}
					}
					else
					{
						fd1.setVisible(true);

					}

					filename = fd1.getFile();

					if (filename == null)
					{
						fd1 = null;

						return true;
					}

					filename = fd1.getDirectory() + filename;
					GMLobject GMLo   = loadFile(filename);
					dnac = new dna(this);
					dnac.fillTaxaInfo(GMLo);
					return true;
				}
				else if (label.equals("Select NEXUS/PHYLIP Sequence file"))
				{
					filename = null;
					dnac = new dna(this);

					if (fd2 == null)
					{

						try
						{
							fd2 = new FileDialog(this, "Open DNA File (Nexus or Phylip sequential)", FileDialog.LOAD);
							fd2.setVisible(true);

						}
						catch (Throwable e)
						{

							MessageDialog dg  = new MessageDialog(this, "Error", "It appears your VM does not allow file loading.", true);

							return true;
						}
					}
					else
					{
						fd2.setVisible(true);

					}

					filename = fd2.getFile();

					if (filename == null)
					{
						fd2 = null;

						return true;
					}

					infilelabel.setText("  " + filename + "  ");
					progressBar.setValue(0);
					calcLimitLabel.setText("Connection Limit      ");
					// progressBar.update(frame.progressBar.getGraphics());
					outfile = filename;
					outfile = outfile.concat(".graph");
					filename = fd2.getDirectory() + filename;

					if (filename == null)
					{

						JFrame frame  = new JFrame();
						JOptionPane.showMessageDialog(frame, "Cannot open data file", "TCS warning", JOptionPane.WARNING_MESSAGE);
						frame.dispose();
						System.exit(0);
					}

					run_button.setEnabled(true);
					// stop_button.setEnabled(true);

					return true;
				}
				else if (label.equals("Select NEXUS/PHYLIP Distance file"))
				{
					filename = null;
					dnac = new dna(this);

					if (fd2 == null)
					{

						try
						{
							fd2 = new FileDialog(this, "Open DNA Distances File (Nexus or Phylip lower matrix)", FileDialog.LOAD);
							fd2.setVisible(true);

						}
						catch (Throwable e)
						{

							MessageDialog dg  = new MessageDialog(this, "Error", 
							"It appears your VM does not allow file loading.", true);

							return true;
						}
					}
					else
					{
						fd2.setVisible(true);

					}

					filename = fd2.getFile();

					if (filename == null)
					{
						fd2 = null;

						return true;
					}

					infilelabel.setText("  " + filename +  "  ");
					progressBar.setValue(0);
					calcLimitLabel.setText("Connection Limit      ");
					// progressBar.update(frame.progressBar.getGraphics());
					outfile = filename;
					outfile = outfile.concat(".graph");
					filename = fd2.getDirectory() + filename;
					doDistances = true;

					if (filename == null)
					{

						JFrame frame  = new JFrame();
						JOptionPane.showMessageDialog(frame, "Cannot open distance file", 
						"TCS warning", JOptionPane.WARNING_MESSAGE);
						frame.dispose();
						System.exit(0);
					}

					run_button.setEnabled(true);
					// stop_button.setEnabled(true);

					return true;
				}
				else if (label.equals("Save Graph (GML)") ||
						label.equals("Save Graph As (GML)"))
				{
					try
					{

						String filename;

						if (label.equals("Save Graph As (GML)") || filename_ == null)
						{

							//FileDialog fd;
							if (fd == null)
							{

								try
								{
									fd = new FileDialog(this, "Save VGJ File (GML) Graph", FileDialog.SAVE);
									fd.setVisible(true);

								}
								catch (Throwable e)
								{

									MessageDialog dg  = new MessageDialog(this, "Error", 
									"It appears your VM does not allow file saving.", true);

									return true;
								}
							}
							else
							{
								fd.setVisible(true);

							}

							filename = fd.getFile();

							if (filename == null)
							{
								fd = null;

								return true;
							}

							// Work around JDK Windows bug.
							if (filename.endsWith(".*.*"))
							{

								String tmpstr  = filename.substring(0, filename.length() - 4);
								filename = tmpstr;
							}

							filename = fd.getDirectory() + filename;
						}
						else
						{
							filename = filename_;
						}

						PrintStream ps      = new PrintStream(new FileOutputStream(filename));

						if (GMLfile_ == null)
						{
							GMLfile_ = new GMLobject(null, GMLobject.GMLfile);
							GMLfile_.addObjectToEnd(new GMLobject("graph", GMLobject.GMLlist));
						}

						GMLobject gmlgraph  = GMLfile_.getGMLSubObject("graph", GMLobject.GMLlist, false);
						graph_.setGMLvalues(gmlgraph);
						gmlgraph.prune();
						ps.println(GMLfile_.toString(0));
						ps.close();
						filename_ = filename;
						setTitle_();
						dnac = new dna(this);
						dnac.fillTaxaInfo(gmlgraph);
						//load the info into the dna stuff...
					}
					catch (IOException e)
					{

						MessageDialog dg  = new MessageDialog(this, "Error", e.getMessage(), true);
					}
				}
				else if (label.equals("Exit This Window"))
				{
					Destroy();
				}
				else if (label.equals("Delete Selected Items"))
				{
					graphCanvas_.deleteSelected(true);
				}
				else if (label.equals("Select All"))
				{
					graphCanvas_.selectAll();
				}
				else if (label.equals("Select Root"))
				{
					graphCanvas_.selectRoot();
				}
				else if (label.equals("Remove All Edge Bends"))
				{
					graphCanvas_.removeEdgeBends();
				}
				else if (label.equals("Remove All Groups"))
				{
					graphCanvas_.removeGroups();
				}
				else if (label.equals("Group Control"))
				{

					if (groupControl_ == null)
					{
						groupControl_ = new GroupControl(this, graphCanvas_);
					}
					else
					{
						groupControl_.showMe();
					}
				}
				else if (label.equals("Set New Node Properties"))
				{
					graphCanvas_.setNodeProperties(true);
				}
				else if (label.equals("Set Node Spacing"))
				{

					if (algPropDialog_ == null)
					{
						algPropDialog_ = new AlgPropDialog(this, graphCanvas_);
					}
					else
					{
						algPropDialog_.showMe();
					}
				}
				else if (label.equals("Set Font"))
				{

					if (fontPropDialog_ == null)
					{
						fontPropDialog_ = new FontPropDialog(this, graphCanvas_);
					}
					else
					{
						fontPropDialog_.showMe();
					}
				}
				else if (label.equals("Edit Text Representation (GML)"))
				{
					graphCanvas_.unselectItems();

					GraphEdit ge  = new GraphEdit(graph_, graphCanvas_);
					ge.pack();
					ge.setVisible(true);

				}
				else if (label.equals("PostScript Output"))
				{

					if (psDialog_ == null)
					{
						psDialog_ = new PSdialog(this, graphCanvas_);
					}
					else
					{
						psDialog_.pack();
						psDialog_.setVisible(true);

					}
				}
				else if (label.equals("PICT Format Output"))
				{

					if (pictDialog_ == null)
					{
						pictDialog_ = new pictdialog(this, graphCanvas_);
					}
					// else
					// {
					// pictDialog_.pack();
					// pictDialog_.setVisible(true);

					// }
					pictDialog_.pack();
					pictDialog_.setVisible(true);

				}
				//removed Nesting option until we are sure it works  SW 4 July 03
				/*else if (label.equals("Cladograph nesting"))
				{
					//added 9-11 jake
					//					GMLobject GMLo = loadFile(filename_);
					// do I want to take care of this when it is loaded or when nesting is done???
					//					dnac.fillTaxaInfo(GMLo);
					//call a nesting program of the graph
					//					System.out.println("I am going to do a cladogram");
					//					System.out.println("this uses the most recently saved graph.  Would you like to save the current one?");
					if (nestDialog_ == null)
					{
						nestDialog_ = new NestDialog(this, graphCanvas_, dnac);
					}
					else
					{
						nestDialog_.pack();
						nestDialog_.setVisible(true);

					}
				}*/
				/*else if (label.equals("Plot histogram"))
				{
					new Histogram(dnac.outweights, dnac.xlabels);
				}*/
			}
		}
		else if (event.target instanceof Button)
		{

			if (((String) what).equals("Scale / 1.25"))
			{
				scale_ /= 1.25;
				graphCanvas_.setScale(scale_);
				scaleLabel_.setText("Scale: " + scale_);
			}
			else if (((String) what).equals("Scale * 1.25"))
			{
				scale_ *= 1.25;
				graphCanvas_.setScale(scale_);
				scaleLabel_.setText("Scale: " + scale_);
			}
			else if (((String) what).equals("Scale = 1"))
			{
				scale_ = 1.0;
				graphCanvas_.setScale(scale_);
				scaleLabel_.setText("Scale: " + scale_);
			}
			else if (((String) what).equals("Center"))
			{

				DDimension port_dim  = viewingPanel_.getPortSize();
				DDimension cont_dim  = viewingPanel_.getContentSize();
				double x             = (cont_dim.width - port_dim.width) / 2.0;
				double y             = (cont_dim.height - port_dim.height) / 2.0;
				viewingPanel_.scrollTo((int) x, (int) y);
				portScroller_.setOffset(x, y);
			}
			else if (((String) what).equals("RUN"))
			{

				//timer.start();
				int args  = 0;
				if (!gapmode)
				{
					args = 1;
				}
				dnac.dodna(filename, fd2.getDirectory() + outfile, 1, doDistances, fd2.getDirectory() + outfile + ".log");

				if (dnac.graph_exists)
				{
					loadFile(fd2.getDirectory() + outfile);
					graphCanvas_.selectRoot();
					applyAlgorithm("Tree Down");
					run_button.setEnabled(false);
					try
					{
						PrintStream ps      = new PrintStream(new FileOutputStream(filename_));

						if (GMLfile_ == null)
						{
							GMLfile_ = new GMLobject(null, GMLobject.GMLfile);
							GMLfile_.addObjectToEnd(new GMLobject("graph", GMLobject.GMLlist));
						}

						GMLobject gmlgraph  = GMLfile_.getGMLSubObject("graph", GMLobject.GMLlist, false);
						graph_.setGMLvalues(gmlgraph);
						gmlgraph.prune();
						ps.println(GMLfile_.toString(0));
						ps.close();
					}
					catch (FileNotFoundException fnfe)
					{
						System.err.println("File suddenly disappeared!");
					}

					fd2 = null;
				}
				else
				{
					System.exit(0);
				}
			}
			else if (((String) what).equals("STOP"))
			{

				//timer.stop();
				//System.exit(0);
				hide();
				cancel = true;
			}
		}

		return true;
	}


	public void addAlgorithm(GraphAlgorithm alg, String name)
	{

		MenuItem menuitem;
		menuitem = new MenuItem(name);
		algorithmMenu_.add(menuitem);

		// Algorithms keyed by menuitems.
		algHashTable_.put(menuitem, alg);
		algNameHashTable_.put(name, alg);
	}


	public void addAlgorithm(GraphAlgorithm alg, String menuname, String name)
	{

		Menu menu          = (Menu) menuHashTable_.get(menuname);

		if (menu == null)
		{

			return;
		}

		MenuItem menuitem  = new MenuItem(name);
		menu.add(menuitem);
		algHashTable_.put(menuitem, alg);
		algNameHashTable_.put(menuname + "." + name, alg);
	}


	public void addAlgorithmMenu(String name)
	{

		Menu menu;
		menu = new Menu(name);
		algorithmMenu_.add(menu);

		// Menus keyed by names.
		menuHashTable_.put(name, menu);
	}


	public void applyAlgorithm(String name)
	{

		GraphAlgorithm alg  = (GraphAlgorithm) algNameHashTable_.get(name);

		if (alg != null)
		{
			applyAlgorithm_(alg);
		}
	}


	public void applyAlgorithm_(GraphAlgorithm alg)
	{

		if (graph_.numberOfNodes() < 1)
		{
			new MessageDialog(this, "Error", "Graph is empty.", true);
		}
		else
		{
			graph_.removeGroups();
			// Remove group nodes.
			graph_.pack();
			// Pack the indexes.

			String msg;
			graphCanvas_.setWireframe(true);
			msg = alg.compute(graph_, graphCanvas_);
			graphCanvas_.setWireframe(false);

			if (msg != null)
			{
				new MessageDialog(this, "Message", msg, true);
			}

			graphCanvas_.update(true);
		}
	}


	public boolean handleEvent(Event event)
	{

		if (event.target instanceof ScrolledPanel)
		{

			if (event.id == ScrolledPanel.RESIZE)
			{

				DDimension tmp_dim;
				tmp_dim = viewingPanel_.getPortSize();
				portScroller_.setPortSize(tmp_dim.width, tmp_dim.height);
				tmp_dim = viewingPanel_.getContentSize();
				portScroller_.setContentSize(tmp_dim.width, tmp_dim.height);
				tmp_dim = viewingPanel_.getOffset();
				portScroller_.setOffset(tmp_dim.width, tmp_dim.height);

				return true;
			}
			else if (event.id == ScrolledPanel.OFFSET)
			{

				DDimension tmp_dim  = viewingPanel_.getOffset();
				portScroller_.setOffset(tmp_dim.width, tmp_dim.height);

				return true;
			}
		}
		else if (event.target instanceof ViewportScroller)
		{

			if (event.id == ViewportScroller.SCROLL)
			{
				graphCanvas_.setWireframe(true);
				viewingPanel_.scrollTo((int) portScroller_.getOffsetX(), (int) portScroller_.getOffsetY());
			}

			if (event.id == ViewportScroller.DONE)
			{
				graphCanvas_.setWireframe(false);
				viewingPanel_.scrollTo((int) portScroller_.getOffsetX(), (int) portScroller_.getOffsetY());
			}
		}
		else if (event.target instanceof AngleControlPanel)
		{

			if (event.id == AngleControlPanel.ANGLE)
			{

				DPoint angles  = (DPoint) event.arg;
				graphCanvas_.setWireframe(true);
				graphCanvas_.setViewAngles(angles.x, angles.y);
			}

			if (event.id == AngleControlPanel.DONE)
			{

				DPoint angles  = (DPoint) event.arg;
				graphCanvas_.setWireframe(false);
				graphCanvas_.setViewAngles(angles.x, angles.y);
			}
		}
		else if (event.target instanceof GraphCanvas)
		{

			if (event.id == GraphCanvas.UPDATE)
			{
				cbmiDirected_.setState(graph_.isDirected());
			}
		}

		// quit from Window Manager menu
		else if (event.id == Event.WINDOW_DESTROY)
		{
			Destroy();

			return false;
		}

		// call inherited handler
		return super.handleEvent(event);
	}


	public boolean keyDown(Event e, int key)
	{

		if (e.id == Event.KEY_PRESS)
		{

			if (key == 's')
			{
				showControls_.setState(!showControls_.getState());
			}
			else
			{
				graphCanvas_.keyDown(e, key);
			}

			if (showControls_.getState())
			{
				controls_.setVisible(true);

			}
			else
			{
				controls_.setVisible(false);
			}

			validate();
		}

		return false;
	}



	public GMLobject loadFile(String filename)
	{

		GMLobject gmlgraph  = null;

		try
		{

			File fname                      = new File(filename);
			int size                        = (int) fname.length();
			int bytes_read                  = 0;
			FileInputStream infile          = new FileInputStream(fname);
			byte[] data                     = new byte[size];

			while (bytes_read < size)
			{
				bytes_read += infile.read(data, bytes_read, size - bytes_read);
			}

			StringBufferInputStream stream  = new StringBufferInputStream(new String(data, 0));
			GMLlexer lexer                  = new GMLlexer(stream);

			try
			{
				GMLfile_ = new GMLobject(lexer, null);

				//            GMLobject
				gmlgraph = GMLfile_.getGMLSubObject("graph", GMLobject.GMLlist, false);

				if (gmlgraph == null)
				{
					GMLfile_ = null;
					new MessageDialog(this, "Error", "File does not contain a graph.", true);

					return gmlgraph;
				}

				Graph newgraph  = null;
				newgraph = new Graph(gmlgraph);
				graph_.copy(newgraph);
				graphCanvas_.update(true);
				filename_ = filename;
				setTitle_();
			}
			catch (ParseError error)
			{
				new MessageDialog(this, "Error", error.getMessage() + " at line " + lexer.getLineNumber() + " at or near \"" + lexer.getStringval() + "\".", true);

			}
			catch (IOException error)
			{

				MessageDialog dg  = new MessageDialog(this, "Error", error.getMessage(), true);
			}
		}
		catch (FileNotFoundException e)
		{

			MessageDialog dg  = new MessageDialog(this, "Error", "Error loading file  \"" + filename + "\".", true);
		}
		catch (IOException e)
		{

			MessageDialog dg  = new MessageDialog(this, "Error", e.getMessage(), true);
		}
		return gmlgraph;
	}


	public void selectNode(int node_index)
	{
		graphCanvas_.selectNode(node_index);
	}


	private void setTitle_()
	{
		if (filename_ != null)
		{
			setTitle("TCS " + dna.VERSION + ":   " + filename_);
		}
	}

	// Function is called on an exit menu choice or delete from the WM menu
	private void Destroy()
	{
		dispose();
	}


	private void construct(Graph graph_in)
	{
		algHashTable_ = new Hashtable();
		algNameHashTable_ = new Hashtable();
		menuHashTable_ = new Hashtable();

		// set main font
		Font guiFont = new Font("Charcoal", Font.PLAIN, 11);

		// create menus
		boolean directed           = graph_in.isDirected();
		MenuBar menubar            = new MenuBar();
		Menu menu                  = new Menu("File");
		Menu TCSmenu               = new Menu("TCS");

		menu.add(new MenuItem("-"));
		menu.add(new MenuItem("Select NEXUS/PHYLIP Sequence file"));
		menu.add(new MenuItem("-"));

		menu.add(new MenuItem("Select NEXUS/PHYLIP Distance file"));
		menu.add(new MenuItem("-"));
		menu.add(new MenuItem("Open Graph (GML)"));
		menu.add(new MenuItem("Save Graph (GML)"));
		menu.add(new MenuItem("Save Graph As (GML)"));

		menu.add(new MenuItem("-"));
		menu.add(new MenuItem("Save network as PostScript"));
		menu.add(new MenuItem("save network as PICT"));
		menu.add(new MenuItem("-"));
		
		// removed Nesting option, July 4, 03 [SW][DP]
		// menu.add(new MenuItem("Cladograph nesting"));  
		// menu.add(new MenuItem("Base Pair Mappings"));//jake 02-07-01
		
		menu.add(new MenuItem("-"));
		menu.add(new MenuItem("Exit This Window"));
		menubar.add(menu);
		algorithmMenu_ = new Menu("Tree");
		menubar.add(algorithmMenu_);
		TCSmenu.add(new MenuItem("Help"));
		TCSmenu.add(new MenuItem("Citation"));
		TCSmenu.add(new MenuItem("TCS web site"));
		TCSmenu.add(new MenuItem("Credits"));
		menubar.add(TCSmenu);

		// removed weights option [DP]
		// weightsMenu.add(new MenuItem("Plot histogram"));
		// weightsMenu.setEnabled(true);
		// menubar.add(weightsMenu);

		menu = new Menu("Edit Graph");
		menu.add(new MenuItem("Select All"));
		menu.add(new MenuItem("Select Root"));
		menu.add(new MenuItem("Delete Selected Items"));
		menu.add(new MenuItem("Remove All Edge Bends"));
		menu.add(new MenuItem("Remove All Groups"));
		menu.add(new MenuItem("Group Control"));
		menu.add(new MenuItem("Edit Text Representation (GML)"));
		menubar.add(menu);
		menu = new Menu("Properties");
		progressBar = new JProgressBar(0, 100);
		progressBar.setFont(guiFont);
		progressBar.setValue(0);
		progressBar.setStringPainted(true);
		
		showControls_ = new CheckboxMenuItem("Show Controls  [s]");
		showControls_.setState(true);
		menu.add(showControls_);

		CheckboxMenuItem cbmi      = new CheckboxMenuItem("Directed");
		cbmiDirected_ = cbmi;
		if (directed)
			{
			cbmi.setState(true);
			}
		menu.add(cbmi);
		menu.add(new MenuItem("Set New Node Properties"));
		menu.add(new MenuItem("Set Node Spacing"));
		menu.add(new MenuItem("Set Font"));
		cbmi = new CheckboxMenuItem("Scale Node Size");
		cbmi.setState(true);
		menu.add(cbmi);
		cbmi = new CheckboxMenuItem("Use Node ID As Default Label");
		cbmi.setState(true);
		menu.add(cbmi);
		cbmi = new CheckboxMenuItem("High Quality Display");
		cbmi.setState(true);
		menu.add(cbmi);
		menubar.add(menu);
		setMenuBar(menubar);
		getContentPane().setLayout(new BorderLayout());

		// panel for controls
		p = new LPanel();
		p.setFont (guiFont);
		p.setForeground (Color.black);
		p.setBorder(BorderFactory.createEtchedBorder());
		
		// Lay out everything
		p.addLineLabel("TCS CLADOGRAM ESTIMATION", 0);
		infilelabel = new Label("No input file    ");
		p.addComponent(infilelabel, 1, -1, 1, 1, 0, 0);

		run_button.setFont(guiFont);
		run_button.setEnabled(false);
		p.addComponent(run_button, 1, -1, 1, 1, 0, 0);
		p.addLineLabel("", 0);
		p.addComponent(progressBar, 1, -1, 1, 1, 0, 0);
		p.addLineLabel("", 0);

		JPanel first               = new JPanel();
		first.setFont(guiFont);
		
		CheckboxGroup mode_group   = new CheckboxGroup();
		Checkbox cb                = new Checkbox("Calculate", mode_group, true);
		cb.setFont(guiFont);
		first.add(cb, "West");

		conLimit = new Choice();
		conLimit.setFont(guiFont);
		int values                 = 90;
		while (values < 100)
			{
			conLimit.addItem("" + values + "%");
			values++;
			}
		first.add(conLimit, "Center");
		conLimit.select(5);

		calcLimitLabel = new Label("Connection limit");
		calcLimitLabel.setFont(new Font("Charcoal", Font.PLAIN, 11));
		first.add(calcLimitLabel, "East");
		p.addComponent(first, 1, -1, 1, 1, 0, 0);
		p.addLineLabel("", 0);

		JPanel second = new JPanel();
		second.setFont(guiFont);
		manualBox = new Checkbox("Fix Connection Limit At ", mode_group, false);
		manualBox.setFont(guiFont);
		second.add(manualBox, "West");
		second.add(manualConnections, "Center");
		second.add(new Label("steps"), "East");
		p.addComponent(second, 1, -1, 1, 1, 0, 0);
		p.addLineLabel("", 0);
		manualConnections.setEnabled(false);

		//pop-up list of choices
		Choice choicegaps;
		choicegaps = new Choice();
		choicegaps.setFont(guiFont);
		choicegaps.addItem("Gaps = 5th state");
		choicegaps.addItem("Gaps = missing");
		p.addComponent(choicegaps, 1, -1, 1, 1, 0, 0);
		p.addLineLabel("", 0);

		//pop-up list of choices
		Choice choicesel;
		choicesel = new Choice();
		choicesel.setFont(guiFont);
		choicesel.addItem("Select Nodes & Branches");
		choicesel.addItem("Select Nodes");
		choicesel.addItem("Select Branches");
		choicesel.addItem("Create Nodes");
		choicesel.addItem("Create Branches");
		p.addComponent(choicesel, 2, -2, 2, 2, 0, 0);
		p.addLineLabel("", 0);

		portScroller_ = new ViewportScroller(90, 90, 500.0, 500.0, 400.0, 400.0, 0.0, 0.0);
		portScroller_.setBackground(Color.white);
		p.constraints.insets.bottom = 0;
		p.addLabel("Viewing Offset", 0, 0, 1.0, 1.0, 0, 0);
		p.constraints.insets.top = p.constraints.insets.bottom = 0;
		p.addComponent(portScroller_, 0, 0, 1.0, 1.0, 0, 0);
		p.constraints.insets.top = p.constraints.insets.bottom = 0;
		p.addButton("Center", guiFont, 0, 0, 1.0, 1.0, 0, 0);
		
		scaleLabel_ = p.addLineLabel("Scale: 1", 0);

		LPanel sp  = new LPanel();
		sp.setFont(guiFont);
		sp.spacing = 0;
		sp.constraints.insets.top = sp.constraints.insets.bottom = 0;
		sp.addButton("Scale / 1.25", guiFont, 1, -1, 1.0, 1.0, 0, 0);
		sp.addButton("Scale = 1", guiFont, 1, -1, 1.0, 1.0, 0, 0);
		sp.addButton("Scale * 1.25", guiFont, 0, -1, 1.0, 1.0, 0, 0);
		sp.finish();
		p.addComponent(sp, 0, 0, 1.0, 1.0, 0, 0);
		p.constraints.insets.top = 0;

// 		Adds a panel for 3D controlling of the graph, not needed [DP]	
//		AngleControlPanel angc = new AngleControlPanel(180,																									 76);
//		p.addComponent(angc, 0, 0, 1.0, 1.0, 1, 0);
		p.addLineLabel("", 0);

		statustextField = new JTextField(25);
		statustextField.setText("STATUS: Waiting");
		statustextField.setForeground(Color.red);
		statustextField.setBackground(Color.lightGray);
		p.addComponent(statustextField, 1, -1, 1, 1, 0, 0);

		// super panel is there just to allow controls to be
		// fixed to top instead of centered
		Panel controls_superpanel  = new Panel();
		controls_superpanel.setFont(guiFont);
		controls_superpanel.add("North", p);
		p.finish();
		getContentPane().add("West", controls_superpanel);
		controls_ = controls_superpanel;
		graph_ = graph_in;
		Node.defaults.setBoundingBox(20, 20, 20);

		// the graph viewing canvas
		graphCanvas_ = new GraphCanvas(graph_, this);
		graphCanvas_.setBackground(Color.white);

		// the graph viewing panel (canvas and scrollbars)
		viewingPanel_ = new ScrolledPanel(graphCanvas_);
		viewingPanel_.setBackground(Color.white);
		getContentPane().add("Center", viewingPanel_);
		validate();
	}

		/*class TimerListener [DP]
			 implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			if (cancel)
			{
				//				System.out.print("Stop button pressed ");
				timer.stop();
				System.exit(0);
			}
		}
	}*/
}
