package clad;
// package EDU.auburn.VGJ.nesting;

import EDU.auburn.VGJ.graph.Graph;
import EDU.auburn.VGJ.gui.*;

import clad.*;

import java.awt.Button;
import java.awt.Checkbox;

/*created sept 11, 2000
 *by Jake Derington
 *
 */
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Frame;
import java.awt.TextField;
import java.awt.FileDialog;


public class NestDialog
		 extends Dialog
{
	private FileDialog fd             = null;
	public dna dnac;
	private Frame frame_;
	private GraphCanvas graphCanvas_;
	private Graph graph_;
	private TextField height_;
	private Checkbox landscape_;
	private TextField margin_;
	private TextField overlap_;
	private TextField pHeight_;
	private TextField pWidth_;
	private TextField pointSize_;
	private TextField printCmd_;
	private TextField width_;
	private String nestFile;


	public NestDialog(Frame frame, GraphCanvas graph_canvas, dna tdna)
	{
		super(frame, "Cladograph nesting", false);

		//			System.out.println("this is nestdialog");
		dnac = tdna;
		graphCanvas_ = graph_canvas;
		frame_ = frame;

		LPanel p  = new LPanel();
		if (tdna == null)
		{
			p.addLineLabel("You must have a cladogram open to use this analysis!", 0);

			p.addButtonPanel("OK", 0);

		}
		else
		{
//			p.addLineLabel("This will execute the nesting procedure of the cladogram", 										 0);
//			p.addLineLabel("This is only effective if intermediate node labeling is on", 										 0);
//			p.addLineLabel("To turn labeling on open the dna.java file and set onOffinter to 1", 										 0);

			p.addLineLabel("Nesting will be performed on the most recently saved cladogram.", 0);
			p.addLineLabel("If you have made changes that you want reflected in the nesting, save the cladogram first.", 0);
			p.addLineLabel("If no file is file is selected, the output file Nesting.txt will be created for the Nesting output.", 0);

			p.addButtonPanel("Nesting Close", 0);
			//			p.addButtonPanel("Level-1 Level-2 Level-3 Level-4 Level-5 Level-6 Level-7 Level-8 Level-9 Level-10 Close", 		 											 0);
		}

		p.finish();
		add("Center", p);
		pack();
		show();
	}


	public boolean action(Event event, Object object)
	{

		if (event.target instanceof Button)
		{

			if ("Close".equals(object))
			{
				hide();
			}
			else if ("Nesting".equals(object))
			{
				nestFile = "Testing.txt";
				if (fd == null)
				{

					try
					{
						fd = new FileDialog(this.frame_, "Save Nesting output as...", FileDialog.SAVE);
						fd.show();
					}
					catch (Throwable e)
					{

						MessageDialog dg  = new MessageDialog(this.frame_, "Error", "It appears your VM does not allow file saving.", true);

						return true;
					}
				}
				else
				{
					fd.show();
				}

				nestFile = fd.getFile();

				if (nestFile == null)
				{
					fd = null;

					return true;
				}

				// Work around JDK Windows bug.
				if (nestFile.endsWith(".*.*"))
				{

					String tmpstr  = nestFile.substring(0, nestFile.length() - 4);
					nestFile = tmpstr;
				}

				nestFile = fd.getDirectory() + nestFile;
				if (nestFile == null)
				{
					nestFile = "Nesting.txt";
				}
				Nesting nest  = new Nesting(dnac, nestFile);
				nest.run(1000);
				hide();
			}
			else if ("OK".equals(object))
			{
				hide();
			}
		}

		return false;
	}


	public boolean handleEvent(Event event)
	{

		// Avoid having everything destroyed.
		if (event.id == Event.WINDOW_DESTROY)
		{
			hide();

			return true;
		}

		return super.handleEvent(event);
	}
}
