package clad;

//import byu.*;

import java.util.Vector;


public class TaxaItem
{

	public final int BIGNUM        = 32767;

	public boolean visited;
	public int levelNumber;

	public char[] characters;
	public Vector compdist;
	// This is our computed distance and there is one for everyone -distance obj
	public Vector dupnames;
	// Keeps track of the names of the duplicate guys
	public int id;
	public boolean isIntermediate;
	public boolean isTip;
	public Vector metricdist;
	// This is a temporary distance array with one for everyone
	public int minRealDist;
	// The minimum distance (we dont allow any wrong connections less than this
	public String name;
	public Vector nbor;
	public Vector newconnections;
	public int numduplicates;
	//the number of individual sequences equal to this one
	public double oweight;
	public Component parent;
	// Keep track of the component we belong to
	public Vector realdist;
	// This only has entries for real taxa (not intermediates)-distance obj
	public double weight;

	// outgroup weights

	TaxaItem(String n, int length, int ident)
	{
		name = new String(n);
		characters = new char[length];
		realdist = new Vector();
		compdist = new Vector();
		nbor = new Vector();
		newconnections = new Vector();
		id = ident;
		numduplicates = 0;
		dupnames = new Vector();
		metricdist = new Vector();
		weight = 0;
		oweight = 0;
		visited = false;
		levelNumber = -1;
	}


	public String toString()
	{
		String result  = "***************************************\n";
		result += "id = " + id;
		result += "\nname = " + name;
		result += "\ncharacter = " + characters;
		result += "\nnumdup = " + numduplicates;
		result += "\nisintermediate = " + isIntermediate;
		result += "\n" + nbor.size() + " nbors = {";
		for (int i = 0; i < nbor.size(); i++)
		{
			//			result += "\n\t" + nbor.elementAt(i).toString();
			result += "\n\t" + ((TaxaItem) nbor.elementAt(i)).id;
		}
		// end for
		result += "\n}";
		return result;
	}
}
